/*
 * ADC.c
 *
 *  Created on: 2022322
 *      Author: User
 */

#include <Main.h>

uint16_t volatile Channel = 0;          // ADCͨλ
uint16_t xdata Temp_Array[2][10] = {0}; //ͨ10λֵ

uint8_t count = 0; //ת
uint16_t Display1_Array[5] = {0};
uint16_t Display2_Array[5] = {0};
static void ADC_Init(void);    //ʼ
static void Get_ADCData(void); //ѶADֵת¶
void Delay_2us(uint16_t fui_i);
ADC_t ADC = {
    0,
    0,
    0,
    0,
    ADC_Init,    // ADCʼ
    Get_ADCData, //תֵ
};
/*
 * @name   ADC_Init
 * @brief  ADCʼ
 * @param  None
 * @retval None
 */
static void ADC_Init(void)
{
  // P0M1 = P0M1 & 0x0F | 0x30;
  // ADCC0 = 0x81;  //ADCԴ ѡڲ׼ѹVREF ѡڲ4V׼ѹ
  ADCC0 = 0x84;  //ADCԴ ѡⲿ׼ѹVREF
  Delay_2us(10); //  ʱ20΢ȴȶ
  ADCC1 = 0x0D;  //ⲿͨ3

  ADCC2 = 0x6D;   // ADCת12λ Ҷ 16Ƶ
  IE1 |= 0x20;    //ADCж
  EA = 1;         //ж
  ADCC0 &= ~0x20; //תɱ־λ
  Channel = Temp1_CHANNEL;
  ADCC1 = (ADCC1 & (~0x07)) | Channel; //лͨͨ
  ADCC0 |= 0x40;                       //ADCת
}
static void Get_ADCData(void) //תADֵ
{
  static uint16_t Temp1 = 0, Temp2 = 0;
  static uint8_t count = 0;
  Temp1 = Temp_Array[0][0] + Temp_Array[0][1] + Temp_Array[0][2] + Temp_Array[0][3] + Temp_Array[0][4] + Temp_Array[0][5] + Temp_Array[0][6] + Temp_Array[0][7] + Temp_Array[0][8] + Temp_Array[0][9];
  Temp1 = Temp1 / 10;                              //10ƽֵ
  ADC.Temp1_Result = (Temp1 * 5 / 4.095 + 5) / 10; //תΪ¶  ڲ4V׼ѹ ɼΪѹѹһ
  Temp1 = 0;

  Temp2 = Temp_Array[1][0] + Temp_Array[1][1] + Temp_Array[1][2] + Temp_Array[1][3] + Temp_Array[1][4] + Temp_Array[1][5] + Temp_Array[1][6] + Temp_Array[1][7] + Temp_Array[1][8] + Temp_Array[1][9];
  Temp2 = Temp2 / 10;                              //10ƽֵ
  ADC.Temp2_Result = (Temp2 * 5 / 4.095 + 5) / 10; //תΪ¶  ڲ4V׼ѹ ɼΪѹѹһ
  Temp2 = 0;
  if (Timer0.ADC_Timer >= TIMER0_80mS)
  {
    Timer0.ADC_Timer = 0;
    Display1_Array[count] = ADC.Temp1_Result;
    Display2_Array[count] = ADC.Temp2_Result;
    count++;
  }

  if (count >= 5)
  {
    count = 0;
    Temp1 = Display1_Array[0] + Display1_Array[1] + Display1_Array[2] + Display1_Array[3] + Display1_Array[4];
    ADC.Display_Temp1_Value = (float)Temp1 / 5 + 0.5;
    Temp2 = Display2_Array[0] + Display2_Array[1] + Display2_Array[2] + Display2_Array[3] + Display2_Array[4];
    ADC.Display_Temp2_Value = (float)Temp2 / 5 + 0.5;
    Temp1 = 0;
    Temp2 = 0;
  }
}

/*
 * @name   ADC_Rpt
 * @brief  ADCжϺ
 * @param  None
 * @retval None
 */
void ADC_Rpt() interrupt ADC_VECTOR
{
  ADCC0 &= ~0x20;               //ADCжϱ־λ
  if (Channel == Temp1_CHANNEL) //ͨ13
  {

    Temp_Array[0][count] = ADCR;
    Channel = Temp2_CHANNEL; //лͨ
  }
  else if (Channel == Temp2_CHANNEL) //ͨ12
  {
    Temp_Array[1][count] = ADCR;
    Channel = Temp1_CHANNEL; //лͨ
    count++;
  }

  if (count >= 10) //ѭ10
    count = 0;
  ADCC1 = (ADCC1 & (~0x07)) | Channel; //лͨͨ
  Delay_2us(10);                       //лͨʱ20us
  ADCC0 |= 0x40;                       //һת
}

/*
 * @name   Delay_2us
 * @brief  ʱ2us
 * @param  fui_i
 * @retval None
 */
void Delay_2us(uint16_t fui_i)
{
  while (fui_i--)
    ;
}

/////////////////////////////////////////////////////////////////////////////////
