/*
 * PID.c
 *
 *  Created on: 20220322
 *      Author: User
 */

#include <Main.h>

#define kp 13.2  //
#define ki 0.067 //
#define kd 35    //΢

//#define pidtime 6 // pid= pidtime * 50ms300ms6675޷
#define iloss 30 //ֵַ˫

sint16_t xdata ek1[2]; // ek0ǰek1ϴ
sint16_t xdata uk1;    // pidֵ[0100]
sint16_t xdata iek1;   //֣ʽ

sint16_t xdata ek2[2]; // ek0ǰek1ϴ
sint16_t xdata uk2;    // pidֵ[0100]
sint16_t xdata iek2;   //֣ʽ

static void Init(void);
static uint8_t Realize(uint8_t CHANNEL, uint16_t temp_val);

PID_t xdata PID_Func = {
    Init,
    Realize};

static void Init(void)
{
    ek1[0] = 0;
    ek1[1] = 0;
    uk1 = 0;
    iek1 = 0;

    ek2[0] = 0;
    ek2[1] = 0;
    uk2 = 0;
    iek2 = 0;
}

/**
 * @brief  PID㷨ʵ
 * @param  CHANNEL ͨ		Temp_Setting Ŀֵ
 *	@note 	
 * @retval  ͨPID
 */
static uint8_t Realize(uint8_t CHANNEL, uint16_t Temp_Setting)
{
    if (CHANNEL == Temp1_CHANNEL)
    {
        ek1[1] = ek1[0];
        ek1[0] = Temp_Setting - ADC.Temp1_Result; //㱾ƫ
        if (ek1[0] > (-iloss) && ek1[0] < iloss)  //ַ
            iek1 += ek1[0];
        uk1 = ek1[0] * kp + iek1 * ki + (ek1[0] - ek1[1]) * kd; // PID
        if (uk1 <= 0)
            uk1 = 0;
        if (uk1 >= 100)
            uk1 = 100;
        return uk1;
    }
    else if (CHANNEL == Temp2_CHANNEL) //ͨ2
    {
        ek2[1] = ek2[0];
        ek2[0] = Temp_Setting - ADC.Temp2_Result; //㱾ƫ
        if (ek2[0] > (-iloss) && ek2[0] < iloss)  //ַ
            iek2 += ek2[0];
        uk2 = ek2[0] * kp + iek2 * ki + (ek2[0] - ek2[1]) * kd; // PID
        if (uk2 <= 0)
            uk2 = 0;
        if (uk2 >= 100)
            uk2 = 100;
        return uk2;
    }
    return FALSE;
}
