/*
 * Protocol.c
 *
 *  Created on: 20220312
 *      Author: User
 */

#include <Main.h>

void Analysis(UART_t *UART); //Э鴦
void Send(uint8_t func);     //ݷ

uint8_t Sum_Check(uint8_t *arr, uint8_t Len); //У

Protocol_t xdata Protocol = {
    Analysis,
    Send};

/* Э鳤Ϊ10 ͷ֡ 0A  ڶ֡ λ  ֡ Чݳλ м6λΪЧλ  β֡ΪУλ
    λ01ΪĴ 02ΪдĴ
    мλЧλǰλΪͨ1 һλΪ״̬λ0x00ر 0x01ڼ 0x02¶ȴﵽ
    ڶλΪ¶λ λΪͨ2 ״̬λԼ¶λ
ӣ0A 01 06 00 00 00 00 00 00 66
*/
/*
 * @name   Analysis
 * @brief  Э
 * @param  UART_t
 * @retval None
 */
void Analysis(UART_t *UART)
{
    UART_t *const com = UART;
    uint8_t sum_check = 0, Data_Len = 0;
    if (UART1.ucRec_Flag == TRUE) //֤յ
    {

        sum_check = Sum_Check(UART1.pucRec_Buffer, Protocol_Len);                                 //Уֵ
        Data_Len = UART1.pucRec_Buffer[2];                                                        //ȡݳ
        if ((UART1.pucRec_Buffer[0] == 0x0A) && (UART1.pucRec_Buffer[Data_Len + 3] == sum_check)) //УЭ
        {

            if (UART1.pucRec_Buffer[1] == Register_Read) //Ĵֵ
            {
                Send(Register_Read); //ͷ
            }
            else if (UART1.pucRec_Buffer[1] == Register_Write) //дĴķֵ
            {

                Public.Channel1_StatusFlag = UART1.pucRec_Buffer[3]; //ȡͨ1״̬
                PWM.Heating_Flag1 = Public.Channel1_StatusFlag;
                Public.Setting_Temp1 = UART1.pucRec_Buffer[4];       //ȡͨ1¶
                Public.Setting_Temp1 = Public.Setting_Temp1 << 8;
                Public.Setting_Temp1 |= UART1.pucRec_Buffer[5];      //ȡͨ1¶
                Public.Channel2_StatusFlag = UART1.pucRec_Buffer[6]; //ȡͨ2״̬
                PWM.Heating_Flag2 = Public.Channel2_StatusFlag;
                Public.Setting_Temp2 = UART1.pucRec_Buffer[7];       //ȡͨ2¶
                Public.Setting_Temp2 = Public.Setting_Temp2 << 8;
                Public.Setting_Temp2 |= UART1.pucRec_Buffer[8]; //ȡͨ2¶
                IAP.Save_TempValue();           //¶ȱ浽EEPROM
                Send(Register_Write); //ͷ
            }
            else if (UART1.pucRec_Buffer[1] == Setting_Reg_Read) //ȡ¶ֵ
            {
                Send(Setting_Reg_Read);
            }
        }

        Public.Memory_Clr(UART1.pucRec_Buffer, Protocol_Len); //
        UART1.ucRec_Flag = FALSE;                             //رմڽɱ־λ
    }
}
/*
 * @name   Send
 * @brief  ڷݺ
 * @param  func
 * @retval None
 */
void Send(uint8_t func)
{
    UART1.pucSend_Buffer[0] = 0x0A; //ͷ֡
    UART1.pucSend_Buffer[1] = func; //λ
    UART1.pucSend_Buffer[2] = 0x06; //Чλ
    if (func == Register_Read)
    {
        UART1.pucSend_Buffer[3] = PWM.Heating_Flag1;     //ͨ1ıʶ
        UART1.pucSend_Buffer[4] = (ADC.Display_Temp1_Value >> 8) & 0xFF; //ͨ1ʵʱ¶
        UART1.pucSend_Buffer[5] = ADC.Display_Temp1_Value & 0xFF;
        UART1.pucSend_Buffer[6] = PWM.Heating_Flag2;     //ͨ2״̬
        UART1.pucSend_Buffer[7] = (ADC.Display_Temp2_Value >> 8) & 0xFF; //ͨ2ʵʱ¶
        UART1.pucSend_Buffer[8] = ADC.Display_Temp2_Value & 0xFF;
    }
    else
    {
        UART1.pucSend_Buffer[3] = Public.Channel1_StatusFlag;;          //ͨ1ıʶ
        UART1.pucSend_Buffer[4] = (Public.Setting_Temp1 >> 8) & 0xFF; //ͨ1ʵʱ¶
        UART1.pucSend_Buffer[5] = Public.Setting_Temp1 & 0xFF;
        UART1.pucSend_Buffer[6] = Public.Channel2_StatusFlag;         //ͨ2״̬
        UART1.pucSend_Buffer[7] = (Public.Setting_Temp2 >> 8) & 0xFF; //ͨ2ʵʱ¶
        UART1.pucSend_Buffer[8] = Public.Setting_Temp2 & 0xFF;
    }

    UART1.pucSend_Buffer[9] = Sum_Check(UART1.pucSend_Buffer, Protocol_Len); //ǰ9λͼֵ
    UART1.UART_SendArray(UART1.pucSend_Buffer, Protocol_Len);                //ͷֵ
}
/*
 * @name   Sum_Check
 * @brief  У麯
 * @param  *arr Len
 * @retval None
 * ۼӺchecksumУ㷨ͬܲòͬ㷨㷨ϸ΢
 * üۼӺͼ㷽ʮƴ8λзָԸ8λֵۼӣУͣ
 * У͵ֵʮƵFFҲ255Ҫ䲹ΪУ
 */
uint8_t Sum_Check(uint8_t *arr, uint8_t Len) //У麯
{
    uint8_t i = 0;
    uint16_t Sum = 0;
    for (i = 0; i < (Len - 1); i++)
    {
        Sum += *(arr + i);
    }
    if (Sum > 0xFF) //255 
    {
        Sum = (~(Sum & 0xFF)) + 1;
    }

    return Sum & 0xFF;
}
