 #ifndef HC89S_CONFIG_H_
#define HC89S_CONFIG_H_


#include "HC89S003AF4.h"


//<<< Use Configuration Wizard in Context Menu >>>

/*
*********************************************************************************************************
*	                                   ʱ
*********************************************************************************************************
*/
/*************************************** ϵͳʱ ************************************************/
// <h> ϵͳʱ

// <o.1>  BOR λʱ 
// <0=> رոƵڲ RC 
// <1=> رոƵڲ RC
#define CLOCK_RC_EN_PD_INIT      2


// <e> ڲƵRCʹ
// <i> ϵͳʱԴΪڲƵ RC 32MHZ
#define CLOCK_IN_HIGH_ENABLE          1
// <o> OSCʱƵ
// <i> OSCʱΪڲƵRCƵ
// <0x50=> 32 MHZ
// <0x51=> 16 MHZ
// <0x52=> 08 MHZ
// <0x53=> 04 MHZ
#define CLOCK_IN_HIGH_CLKSWR_INIT      0x51
// <o> CPUʱӣOSCʱӷƵȣ <1-255>
// <i> CPUʱΪOSCʱӷƵ
#define CLOCK_IN_HIGH_CLKDIV_INIT      1
// </e>

// <e> ڲƵRCʹ
// <i> ϵͳʱԴΪڲƵ RC 44KHZ
#define CLOCK_IN_LOW_ENABLE           0
// <o> CPUʱӣOSCʱӷƵȣ <1-255>
// <i> CPUʱΪOSCʱӷƵ
#define CLOCK_IN_LOW_CLKDIV_INIT      0
//   </e>

// <e> ⲿƵʹ
// <i> ϵͳʱԴΪⲿƵ
#define CLOCK_OUT_HIGH_ENABLE           0
// <o.2..3> ⲿƵѡź
// <i> ⲿƵƵ
// <0=> 4M/8M  
// <1=> 4M/8M 
// <3=> ѡ 16M/20M 
#define CLOCK_OUT_HIGH_HXTAL_MODE_SEL_INIT     0
// <o.6..7>  warmup ֵ
// <i> ⲿƵ warmup ֵѡ񣬼ʱԴΪѡⲿƵ
// <0=> 2048 
// <1=> 256
// <2=> 16384
// <3=> 65536
#define CLOCK_OUT_HIGH_HXTAL_CFG_INIT     0
//   </e>

// <e> ⲿƵʹ
// <i> ϵͳʱԴΪⲿƵ
#define CLOCK_OUT_LOW_ENABLE           0
// <o.4..5>  warmup ֵ
// <i> ⲿƵ warmup ֵѡ񣬼ʱԴΪѡⲿƵ
// <0=> 16384 
// <1=> 4096
// <2=> 1024
// <3=> 65536
#define CLOCK_OUT_HIGH_LXTAL_CFG_INIT      0
//   </e>

// <e>  CPUʱƵ
// <i>  ڽ FLASH  IAP дϵͳģʽ֮ǰָĿǰ CPU ʱӵƵ
#define CLOCK_FREQ_CLK_ENABLE           0
// <o>  Ƶ
// <16=> 16MHz 
// <8=> 08MHz
// <4=> 04MHz
// <2=> 02MHz
// <1=> Сڵ 1MHz
#define CLOCK_FREQ_CLK_INIT      16
//   </e>

// <e> ʱ
// <i> ʹ/ʧʱ
#define CLOCK_OUTPUT_ENABLE           0
// <o> ʱѡ 
// <0=> CPUʱ 
// <1=> OSCʱ
// <2=> WDTʱ
// <3=> ⲿʱ
// <4=> ڲƵ RC32M  
// <5=> ڲƵ RC32M 2Ƶ 
// <6=> ڲƵ RC32M 4Ƶ 
// <7=> ڲƵ RC32M 8Ƶ 
#define CLOCK_CLK_OUT_SEL_INIT      0
// <o> ʱӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define CLOCK_CLOCKMAP_INIT      0
//   </e>
// </h>

/*
*********************************************************************************************************
*	                                   ϵͳж
*********************************************************************************************************
*/
// <e> ϵͳж
#define SYSTEM_EA_INIT_ENABLE           1
// <o> жϿ
// <0=> ر
// <1=> 
#define SYSTEM_EA_INIT      1
// </e>

/*
*********************************************************************************************************
*	                                   GPIO
*********************************************************************************************************
*/
//   <e>GPIO
//   <i>оƬ˿ڳʼ
#define GPIO_INIT_ENABLE 1

// <h> P0 ˿ģʽ
// <o.0..3>P00
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 

// <o.4..7>P01
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 
#define GPIO_MODE_P0M0   163
	 
// <o.0..3>P02
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 

// <o.4..7>P03
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 
#define GPIO_MODE_P0M1   56
	 
// <o.0..3>P04
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 

// <o.4..7>P05
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> ©  
#define GPIO_MODE_P0M2   131	 

// <o.0..3>P06
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> ©  

// <o.4..7>P07
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 
#define GPIO_MODE_P0M3   51
// </h>
	
// <h> P1 ˿ģʽ
// <o.0..3>P10
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 

// <o.4..7>P11
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> ©  
#define GPIO_MODE_P1M0   63
	  
// </h>

// <h> P2 ˿ģʽ
// <o.0..3>P20
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 

// <o.4..7>P21
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> ©  
#define GPIO_MODE_P2M0   130
	 
// <o.0..3>P22
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 

// <o.4..7>P23
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 
#define GPIO_MODE_P2M1   136 
	 
// <o.0..3>P24
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 

// <o.4..7>P25
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 
#define GPIO_MODE_P2M2   51	 

// <o.0..3>P26
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 

// <o.4..7>P27
// <3=> Not Used
// <0=> 루ʩأ 
// <1=> 루ʩأ
// <2=> 루ʩأ
// <3=> ģ
// <4=> 루ʩأ
// <5=> 루ʩأ
// <6=> 루ʩأ
// <8=> 
// <9=> ©
// <10=> © 
#define GPIO_MODE_P2M3   168	
// </h>

// <e> P02 ˿
// <i>  P02 ˿
#define GPIO_INIT_PULLRES_ENABLE           0
// <o.0..5> ֵ 
// <0=> 50 K 
// <16=> 100 K
// <32=> 150K
// <48=> 300 K
#define GPIO_PULLRESVALUE_P02      0
//   </e>

// <e> P00 ˿
// <i>  P00 ˿
#define GPIO_INIT_DBC_P00_ENABLE           0
// <o.6..7> ˿ʱ 
// <0=> Fosc /1
// <1=> Fosc /4
// <2=> Fosc /16
// <3=> Fosc /64
// <o.0..5>ʱӸ <0-63>
#define GPIO_DBC_INIT_P00             0
//   </e>

// <e> P01 ˿
// <i>  P01 ˿
#define GPIO_INIT_DBC_P01_ENABLE           0
// <o.6..7> ˿ʱ 
// <0=> Fosc /1
// <1=> Fosc /4
// <2=> Fosc /16
// <3=> Fosc /64
// <o.0..5>ʱӸ <0-63>
#define GPIO_DBC_INIT_P01             0
//   </e>

// <e> P02 ˿
// <i>  P02 ˿
#define GPIO_INIT_DBC_P02_ENABLE           0
// <o.6..7> ˿ʱ 
// <0=> Fosc /1
// <1=> Fosc /4
// <2=> Fosc /16
// <3=> Fosc /64
// <o.0..5>ʱӸ <0-63>
#define GPIO_DBC_INIT_P02             127
// </e>
// </e>	

/*
*********************************************************************************************************
*	                                   λ
*********************************************************************************************************
*/
// <e>  λ
// <i>  öַʽλ
#define RESET_INIT_ENABLE           0

// <e>  BOR 
#define RESET_BORVS_INIT_ENABLE             0
// <o.0..2>  BOR ѹ
// <0=> 1.8 V
// <1=> 2.0 V
// <2=> 2.4 V
// <3=> 2.6 V
// <4=> 3.0 V
// <5=> 3.6 V
// <6=> 3.9 V
// <7=> 4.2 V

// <o.7>  BOR ״̬
// <0=> ر
// <1=> 

// <o.6>  BOR 
// <0=> ر
// <1=> 
#define RESET_BORVS_INIT             129
// <o>ʱӸ <0-255>
// <i>  뷶Χ0~255
// <i>  ʱ = BORDBC[7:0] * 8T CPU  +2 T CPU
// <i>  ע⣺Ҫʹ BOR_DBC_EN BOR 
#define RESET_BORDBC_INIT      255
// </e>

// <e>  ⲿ RST ȥ
#define RESET_RSTDBC_INIT_ENABLE             0
// <o>ʱӸ <0-65535>
// <i>  뷶Χ0~65535
// <i>  ʱ = RSTDBC[7:0] * 8T CPU +2 T CPU
#define RESET_RSTDBC_INIT      255
// </e>

// <e>  ջλ
#define RESET_SPOV_INIT_ENABLE             0
// <o>  ջλ
// <0=> ر
// <1=> 
#define RESET_SPOV_INIT      0
// </e>
// </e>


/*
*********************************************************************************************************
*	                                   ͵ѹLVD
*********************************************************************************************************
*/
// <e>  ͵ѹLVD
#define LVD_INIT_ENABLE             0
//<q.7> LVD ʹ
//<q.6> LVD  P0.2˿ڵѹ
// <o.0..2>  LVD ѹ
// <0=> 1.9 V
// <1=> 2.0 V
// <2=> 2.4 V
// <3=> 2.6 V
// <4=> 3.0 V
// <5=> 3.6 V
// <6=> 3.9 V
// <7=> 4.2 V
#define LVD_LVDCC_INIT            0

//<e.5> LVD ж
#define LVD_LVDIE_INIT            0
// <o.4..5>  жȼ
// <i>  ⲿж0 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define LVD_IP1_INIT      0
// </e>
#define LVD_LVDC_INIT            LVD_LVDIE_INIT+LVD_LVDIE_INIT

// <e>  ⲿ RST ȥ
#define LVD_LVDDBC_INIT_ENABLE             0
// <o>ʱӸ <0-65535>
// <i>  뷶Χ0~65535
// <i>  ʱ = RSTDBC[7:0] * 8T CPU +2 T CPU
#define LVD_LVDDBC_INIT      255
// </e>
// </e>
/*
*********************************************************************************************************
*	                                   Ź
*********************************************************************************************************
*/
// <e>  Ź
#define WDT_INIT_ENABLE             0
/**************************************** ʹWDT *************************************/
#if WDT_INIT_ENABLE
/**************************************** ʹWDTж *************************************/
// <e>  Źж
#define WDT_INT_ENABLE             0
#if WDT_INT_ENABLE
// <o.5> жϿ
// <0=> ر
// <1=> 
#define WDT_EWT_INIT       0
// <o.2..3>  жȼ
// <i>  ⲿж0 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define WDT_IP1_INIT      0
// </e> 
/**************************************** ʧWDTж *************************************/
#else
#define WDT_IP1_INIT                   0
#define WDT_EWT_INIT                   0
#endif

// <o.6> Źλ
// <0=> ر
// <1=> 

// <o.3> Ź͹ģʽ
// <0=> ر
// <1=> 

// <o.0..2>ŹʱʱԴƵ
// <0=> ڲƵ RC44K8 Ƶ
// <1=> ڲƵ RC44K16 Ƶ
// <2=> ڲƵ RC44K32 Ƶ
// <3=> ڲƵ RC44K64 Ƶ
// <4=> ڲƵ RC44K128 Ƶ
// <5=> ڲƵ RC44K256 Ƶ
// <6=> ڲƵ RC44K512 Ƶ
// <7=> ڲƵ RC44K1024 Ƶ
#define WDT_WDTC_INIT      17

// <o>Źʱ<0-255>
// <i>ע⣺
// <i>ʹ WDT еģʽʱע⣬幷ͽָ֮ڵ 3 
// <i>wdt_clkԼ 70us
// <i> 44KHz Ϊм㣬ʵڲƵ RC Ƶʿͨʱ 5 вõ
// <i>ʱ =( WDTƵϵ * (WDTCCR[7:0]+1))/ʵڲƵRCƵʡ
#define WDT_WDTCCR_INIT      255
// </e>
/**************************************** ʧWDT *************************************/
#else
#define WDT_INT_ENABLE                 0
#define WDT_IP1_INIT                   0
#define WDT_WDTC_INIT                 0x4F
#define WDT_EWT_INIT                  0
#define WDT_WDTCCR_INIT               0x00
#endif

/*
*********************************************************************************************************
*	                                   ⲿж
*********************************************************************************************************
*/
// <e> ⲿж
// <i>  ⲿж
#define EXIT_INIT_ENABLE           0
#if EXIT_INIT_ENABLE
/**************************************** ⲿж0 *****************************************/
// <e> ⲿж0
// <i>  ⲿж 0
#define EXIT0_INIT_ENABLE           0
/**************************************** ʹⲿж0 *************************************/
#if EXIT0_INIT_ENABLE
// <o.0>  ܽѡ 
// <i>  ⲿж0 ܽѡλ
// <0=> P00
// <1=> P10
#define EXIT0_INT0_PINS_INIT     0
// <o.0..1>  жϴ
// <i>  ⲿж0 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT0_IT0_INIT      0
// <o.0..1>  жȼ
// <i>  ⲿж0 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define EXIT0_IP0_INIT      0
// <o.0> жϿ
// <0=> ر
// <1=> 
#define EXIT0_EX0_INIT      0
/**************************************** ʧⲿж0 *************************************/
#else
#define EXIT0_INT0_PINS_INIT        0
#define EXIT0_IT0_INIT      0
#define EXIT0_EX0_INIT               0
#define EXIT0_IP0_INIT              0
#endif
// </e>
/**************************************** ⲿж1 *****************************************/
// <e> ⲿж1
// <i>  ⲿж 1
#define EXIT1_INIT_ENABLE           0
/**************************************** ʹⲿж1 *************************************/
#if EXIT1_INIT_ENABLE
// <o.1>  ܽѡ 
// <i>  ⲿж1 ܽѡλ
// <0=> P01
// <1=> P11
#define EXIT1_INT1_PINS_INIT     2
// <o.2..3>  жϴ
// <i>  ⲿж1 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT1_IT1_INIT      4
// <o.4..5>  жȼ
// <i>  ⲿж1 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define EXIT1_IP0_INIT      48
// <o.2> жϿ
// <0=> ر
// <1=> 
#define EXIT1_EX1_INIT       4
/**************************************** ʧⲿж1 *************************************/
#else
#define EXIT1_INT1_PINS_INIT        0
#define EXIT1_IT1_INIT      0
#define EXIT1_EX1_INIT               0
#define EXIT1_IP0_INIT              0
#endif
// </e>


/**************************************** ⲿж2-7 *****************************************/
// <e> ⲿж2-7
// <i>  ⲿж 2-7
#define EXIT2_7_INIT_ENABLE           0
/**************************************** ʹⲿж2-7 *************************************/
#if EXIT2_7_INIT_ENABLE
/**************************************** ⲿж2 *****************************************/
// <e> ⲿж2
// <i>  ⲿж 2
#define EXIT2_INIT_ENABLE           1
/**************************************** ʹⲿж2 *************************************/
#if EXIT2_INIT_ENABLE
// <o.4..5>  жϴ
// <i>  ⲿж2 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT2_IT2_INIT      16
// <o.2> жϿ
// <0=> ر
// <1=> 
#define EXIT2_EINT2_INIT       4
/**************************************** ʧⲿж2 *************************************/
#else
#define EXIT2_IT2_INIT      0
#define EXIT2_EINT2_INIT       0
#endif
// </e>
/**************************************** ⲿж3 *****************************************/
// <e> ⲿж3
// <i>  ⲿж 3
#define EXIT3_INIT_ENABLE           0
/**************************************** ʹⲿж3 *************************************/
#if EXIT3_INIT_ENABLE
// <o.6..7>  жϴ
// <i>  ⲿж3 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT3_IT3_INIT      0
// <o.3> жϿ
// <0=> ر
// <1=> 
#define EXIT3_EINT3_INIT       0
/**************************************** ʧⲿж3 *************************************/
#else
#define EXIT3_IT3_INIT      0
#define EXIT3_EINT3_INIT       0
#endif
// </e>
/**************************************** ⲿж4 *****************************************/
// <e> ⲿж4
// <i>  ⲿж 4
#define EXIT4_INIT_ENABLE           0
/**************************************** ʹⲿж4 *************************************/
#if EXIT4_INIT_ENABLE
// <o.0..1>  жϴ
// <i>  ⲿж4 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT4_IT4_INIT      0
// <o.4> жϿ
// <0=> ر
// <1=> 
#define EXIT4_EINT4_INIT       0
/**************************************** ʧⲿж4 *************************************/
#else
#define EXIT4_IT4_INIT      0
#define EXIT4_EINT4_INIT       0
#endif
// </e>
/**************************************** ⲿж5 *****************************************/
// <e> ⲿж5
// <i>  ⲿж 5
#define EXIT5_INIT_ENABLE           0
/**************************************** ʹⲿж5 *************************************/
#if EXIT5_INIT_ENABLE
// <o.2..3>  жϴ
// <i>  ⲿж5 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT5_IT5_INIT      0
// <o.5> жϿ
// <0=> ر
// <1=> 
#define EXIT5_EINT5_INIT       0
/**************************************** ʧⲿж5 *************************************/
#else
#define EXIT5_IT5_INIT      0
#define EXIT5_EINT5_INIT       0
#endif
// </e>
/**************************************** ⲿж6 *****************************************/
// <e> ⲿж6
// <i>  ⲿж 6
#define EXIT6_INIT_ENABLE           0
/**************************************** ʹⲿж6 *************************************/
#if EXIT6_INIT_ENABLE
// <o.4..5>  жϴ
// <i>  ⲿж6 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT6_IT6_INIT      0
// <o.6> жϿ
// <0=> ر
// <1=> 
#define EXIT6_EINT6_INIT       0
/**************************************** ʧⲿж6 *************************************/
#else
#define EXIT6_IT6_INIT      0
#define EXIT6_EINT6_INIT       0
#endif
// </e>
/**************************************** ⲿж7 *****************************************/
// <e> ⲿж7
// <i>  ⲿж 7
#define EXIT7_INIT_ENABLE           0
/**************************************** ʹⲿж7 *************************************/
#if EXIT7_INIT_ENABLE
// <o.6..7>  жϴ
// <i>  ⲿж7 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT7_IT7_INIT      0
// <o.7> жϿ
// <0=> ر
// <1=> 
#define EXIT7_EINT7_INIT       0
/**************************************** ʧⲿж7 *************************************/
#else
#define EXIT7_IT7_INIT      0
#define EXIT7_EINT7_INIT       0
#endif
// </e>
/**************************************** ⲿж2-7ȼ *************************************/
// <o.4..5>  жȼ
// <i>  ⲿж1 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define EXIT2_7_IP3_INIT      0
/**************************************** ⲿжʹ *************************************/
// <o.6> жϿ
// <0=> ر
// <1=> 
#define EXIT2_7_EX2_7_INIT       64
/**************************************** ʧⲿж2-7 *************************************/
#else
#define EXIT2_INIT_ENABLE           0
#define EXIT3_INIT_ENABLE           0
#define EXIT4_INIT_ENABLE           0
#define EXIT5_INIT_ENABLE           0
#define EXIT6_INIT_ENABLE           0
#define EXIT7_INIT_ENABLE           0
#define EXIT2_IT2_INIT         0
#define EXIT2_EINT2_INIT       0
#define EXIT3_IT3_INIT         0
#define EXIT3_EINT3_INIT       0
#define EXIT4_IT4_INIT         0
#define EXIT4_EINT4_INIT       0
#define EXIT5_IT5_INIT         0
#define EXIT5_EINT5_INIT       0
#define EXIT6_IT6_INIT         0
#define EXIT6_EINT6_INIT       0
#define EXIT7_IT7_INIT         0
#define EXIT7_EINT7_INIT       0
#define EXIT2_7_EX2_7_INIT            0 
#define EXIT2_7_IP3_INIT            0
#endif
// </e>

/**************************************** ⲿж8-15 *****************************************/
// <e> ⲿж8-15
// <i>  ⲿж 8-15
#define EXIT8_15_INIT_ENABLE           0
/**************************************** ʹⲿж8-15 *************************************/
#if EXIT8_15_INIT_ENABLE
/**************************************** ⲿж8 *****************************************/
// <e> ⲿж8
// <i>  ⲿж 8
#define EXIT8_INIT_ENABLE           0
/**************************************** ʹⲿж8 *************************************/
#if EXIT8_INIT_ENABLE
// <o.0..1>  жϴ
// <i>  ⲿж8 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT8_IT8_INIT         2
// <o.0> жϿ
// <0=> ر
// <1=> 
#define EXIT8_EINT8_INIT       0
/**************************************** ʧⲿж8 *************************************/
#else
#define EXIT8_IT8_INIT         0
#define EXIT8_EINT8_INIT       0
#endif
// </e>
/**************************************** ⲿж9 *****************************************/
// <e> ⲿж9
// <i>  ⲿж 9
#define EXIT9_INIT_ENABLE           0
/**************************************** ʹⲿж9 *************************************/
#if EXIT9_INIT_ENABLE
// <o.2..3>  жϴ
// <i>  ⲿж9 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT9_IT9_INIT         0
// <o.1> жϿ
// <0=> ر
// <1=> 
#define EXIT9_EINT9_INIT       0
/**************************************** ʧⲿж9 *************************************/
#else
#define EXIT9_IT9_INIT         0
#define EXIT9_EINT9_INIT       0
#endif
// </e>
/**************************************** ⲿж10 *****************************************/
// <e> ⲿж10
// <i>  ⲿж 10
#define EXIT10_INIT_ENABLE           0
/**************************************** ʹⲿж10 *************************************/
#if EXIT10_INIT_ENABLE
// <o.4..5>  жϴ
// <i>  ⲿж10 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT10_IT10_INIT         0
// <o.2> жϿ
// <0=> ر
// <1=> 
#define EXIT10_EINT10_INIT       0
/**************************************** ʧⲿж10 *************************************/
#else
#define EXIT10_IT10_INIT         0
#define EXIT10_EINT10_INIT       0
#endif
// </e>
/**************************************** ⲿж11 *****************************************/
// <e> ⲿж11
// <i>  ⲿж 11
#define EXIT11_INIT_ENABLE           0
/**************************************** ʹⲿж11 *************************************/
#if EXIT11_INIT_ENABLE
// <o.6..7>  жϴ
// <i>  ⲿж11 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT11_IT11_INIT         0
// <o.3> жϿ
// <0=> ر
// <1=> 
#define EXIT11_EINT11_INIT       0
/**************************************** ʧⲿж11 *************************************/
#else
#define EXIT11_IT11_INIT         0
#define EXIT11_EINT11_INIT       0
#endif
// </e>
/**************************************** ⲿж12 *****************************************/
// <e> ⲿж12
// <i>  ⲿж 12
#define EXIT12_INIT_ENABLE           0
/**************************************** ʹⲿж12 *************************************/
#if EXIT12_INIT_ENABLE
// <o.0..1>  жϴ
// <i>  ⲿж12 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT12_IT12_INIT         0
// <o.4> жϿ
// <0=> ر
// <1=> 
#define EXIT12_EINT12_INIT       0
/**************************************** ʧⲿж12 *************************************/
#else
#define EXIT12_IT12_INIT         0
#define EXIT12_EINT12_INIT       0
#endif
// </e>
/**************************************** ⲿж13 *****************************************/
// <e> ⲿж13
// <i>  ⲿж 13
#define EXIT13_INIT_ENABLE           0
/**************************************** ʹⲿж13 *************************************/
#if EXIT13_INIT_ENABLE
// <o.2..3>  жϴ
// <i>  ⲿж13 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT13_IT13_INIT         0
// <o.5> жϿ
// <0=> ر
// <1=> 
#define EXIT13_EINT13_INIT       0
/**************************************** ʧⲿж13 *************************************/
#else
#define EXIT13_IT13_INIT         0
#define EXIT13_EINT13_INIT       0
#endif
// </e>
/**************************************** ⲿж14 *****************************************/
// <e> ⲿж14
// <i>  ⲿж 14
#define EXIT14_INIT_ENABLE           0
/**************************************** ʹⲿж14 *************************************/
#if EXIT14_INIT_ENABLE
// <o.4..5>  жϴ
// <i>  ⲿж14 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT14_IT14_INIT         0
// <o.6> жϿ
// <0=> ر
// <1=> 
#define EXIT14_EINT14_INIT       0
/**************************************** ʧⲿж14 *************************************/
#else
#define EXIT14_IT14_INIT         0
#define EXIT14_EINT14_INIT       0
#endif
// </e>
/**************************************** ⲿж15 *****************************************/
// <e> ⲿж15
// <i>  ⲿж 15
#define EXIT15_INIT_ENABLE           0
/**************************************** ʹⲿж15 *************************************/
#if EXIT15_INIT_ENABLE
// <o.6..7>  жϴ
// <i>  ⲿж15 ѡλ
// <0=> ͵ƽж
// <1=> ½ж
// <2=> ж
// <3=> ˫ж
#define EXIT15_IT15_INIT         64
// <o.7> жϿ
// <0=> ر
// <1=> 
#define EXIT15_EINT15_INIT       128
/**************************************** ʧⲿж15 *************************************/
#else
#define EXIT15_IT15_INIT         0
#define EXIT15_EINT15_INIT       0
#endif
// </e>

/**************************************** ⲿж8-15ȼ *************************************/
// <o.6..7>  жȼ
// <i>  ⲿж1 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define EXIT8_15_IP3_INIT      192
/**************************************** ⲿжʹ *************************************/
// <o.7> жϿ
// <0=> ر
// <1=> 
#define EXIT8_15_EX8_15_INIT       0
/**************************************** ʧⲿж8-15 *************************************/
#else
#define EXIT8_INIT_ENABLE           0
#define EXIT9_INIT_ENABLE           0
#define EXIT10_INIT_ENABLE          0
#define EXIT11_INIT_ENABLE          0
#define EXIT12_INIT_ENABLE          0
#define EXIT13_INIT_ENABLE          0
#define EXIT14_INIT_ENABLE          0
#define EXIT15_INIT_ENABLE          0
#define EXIT8_IT8_INIT              0
#define EXIT8_EINT8_INIT            0
#define EXIT9_IT9_INIT              0
#define EXIT9_EINT9_INIT            0
#define EXIT10_IT10_INIT            0
#define EXIT10_EINT10_INIT          0
#define EXIT11_IT11_INIT            0
#define EXIT11_EINT11_INIT          0
#define EXIT12_IT12_INIT            0
#define EXIT12_EINT12_INIT          0
#define EXIT13_IT13_INIT            0
#define EXIT13_EINT13_INIT          0
#define EXIT14_IT14_INIT            0
#define EXIT14_EINT14_INIT          0
#define EXIT15_IT15_INIT            0
#define EXIT15_EINT15_INIT          0
#define EXIT8_15_IP3_INIT           0
#define EXIT8_15_EX8_15_INIT           0 
#endif
// </e>
#else
#define EXIT0_INIT_ENABLE           0
#define EXIT0_INT0_PINS_INIT        0
#define EXIT0_IT0_INIT      0
#define EXIT0_EX0_INIT               0
#define EXIT0_IP0_INIT              0
#define EXIT1_INIT_ENABLE           0
#define EXIT1_INT1_PINS_INIT        0
#define EXIT1_IT1_INIT      0
#define EXIT1_EX1_INIT               0
#define EXIT1_IP0_INIT              0
#define EXIT2_7_INIT_ENABLE           0
#define EXIT2_INIT_ENABLE           0
#define EXIT3_INIT_ENABLE           0
#define EXIT4_INIT_ENABLE           0
#define EXIT5_INIT_ENABLE           0
#define EXIT6_INIT_ENABLE           0
#define EXIT7_INIT_ENABLE           0
#define EXIT2_IT2_INIT         0
#define EXIT2_EINT2_INIT       0
#define EXIT3_IT3_INIT         0
#define EXIT3_EINT3_INIT       0
#define EXIT4_IT4_INIT         0
#define EXIT4_EINT4_INIT       0
#define EXIT5_IT5_INIT         0
#define EXIT5_EINT5_INIT       0
#define EXIT6_IT6_INIT         0
#define EXIT6_EINT6_INIT       0
#define EXIT7_IT7_INIT         0
#define EXIT7_EINT7_INIT       0
#define EXIT2_7_EX2_7_INIT          0 
#define EXIT2_7_IP3_INIT            0
#define EXIT8_15_INIT_ENABLE        0
#define EXIT8_INIT_ENABLE           0
#define EXIT9_INIT_ENABLE           0
#define EXIT10_INIT_ENABLE          0
#define EXIT11_INIT_ENABLE          0
#define EXIT12_INIT_ENABLE          0
#define EXIT13_INIT_ENABLE          0
#define EXIT14_INIT_ENABLE          0
#define EXIT15_INIT_ENABLE          0
#define EXIT8_IT8_INIT              0
#define EXIT8_EINT8_INIT            0
#define EXIT9_IT9_INIT              0
#define EXIT9_EINT9_INIT            0
#define EXIT10_IT10_INIT            0
#define EXIT10_EINT10_INIT          0
#define EXIT11_IT11_INIT            0
#define EXIT11_EINT11_INIT          0
#define EXIT12_IT12_INIT            0
#define EXIT12_EINT12_INIT          0
#define EXIT13_IT13_INIT            0
#define EXIT13_EINT13_INIT          0
#define EXIT14_IT14_INIT            0
#define EXIT14_EINT14_INIT          0
#define EXIT15_IT15_INIT            0
#define EXIT15_EINT15_INIT          0
#define EXIT8_15_IP3_INIT           0
#define EXIT8_15_EX8_15_INIT        0 
#endif
// </e>
/*************************************** ʱ0  ************************************************/
// <e> ʱ0
// <i>  ʱ0
#define TIMER0_INIT_ENABLE                      0
/**************************************** ʱ0ʹ *************************************/
#if TIMER0_INIT_ENABLE
// <o.2> ʱ0
// <0=> ڲʱ 
// <1=> ⲿ
#define TIMER0_CT0_INIT           0
// <o.1> ʱ0 жϿ
// <0=> ر
// <1=> 
#define TIMER0_ET0_INIT     2
// <o.2..3> ʱ0 жȼ
// <i>  ʱ0 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define TIMER0_IP0_INIT      12
// <o.0..1>  ʱ0ʽ
// <i>  ע⣺ʽ 3 ʱ T0 ռ T1  TR1TF1 жԴ, TR1  T0 ռãʱҪر T1ɽ T1 Ϊʽ 3
// <0=> ʽ0 16 λװضʱ/
// <1=> ʽ1 16 λʱ/
// <2=> ʽ2 8 λԶװֵʱ/
// <3=> ʽ3 T0 ֳ(TL0/TH0) 8 λʱ/T1ֹͣ
#define TIMER0_M0_INIT     0
// <o.0>  ʱ0ʱԴ
// <i>  ʱϵͳʱԴƵѡλ
// <0=> ʱ0 ʱΪ Fosc /12
// <1=> ʱ0 ʱΪ Fosc
#define TIMER0_T0X12_INIT           1
// <h> ʱ0ſ
// <o.4>  ʱ0п
// <0=> ֹͣ ʱ0 
// <1=>  ʱ0 
#define TIMER0_TR0_INIT           16
// <o.3>  ʱ0ſλ
// <0=> ֻ TR0  Tx
// <1=> ֻ INT0 ˿ڵƽΪߵƽʱ TR0  1ʱ0 Ź
#define TIMER0_GATE0_INIT           0
// </h>
// <e.1> ʱ0Ƚ
#define TIMER0_T0OUT_INIT                0
// <o>  ʱ0ӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define TIMER0_T0MAP_INIT      0x00
// </e>
// <h> ʱ0ʱ
// <o> ߰λ<0-255>
#define TIMER0_TH0_INIT      0xFA
// <o> Ͱλ<0-255>
#define TIMER0_TL0_INIT      0xCB
// </h>
#else
#define TIMER0_CT0_INIT        0
#define TIMER0_ET0_INIT        0
#define TIMER0_M0_INIT         0
#define TIMER0_IP0_INIT        0
#define TIMER0_T0X12_INIT      0
#define TIMER0_TR0_INIT        0
#define TIMER0_GATE0_INIT      0
#define TIMER0_T0OUT_INIT      0
#define TIMER0_T0MAP_INIT      0
#define TIMER0_TL0_INIT        0x00
#define TIMER0_TH0_INIT        0x00
#endif
// </e>

/****************************************** ʱ1  *********************************************/
// <e> ʱ1
// <i>  ʱ1
#define TIMER1_INIT_ENABLE                      0
/******************************************* ʱ1ʹ *********************************************/
#if TIMER1_INIT_ENABLE
// <o.6> ʱ1
// <0=> ڲʱ 
// <1=> ⲿ
#define TIMER1_CT1_INIT           0
// <o.3> ʱ1 жϿ
// <0=> ر
// <1=> 
#define TIMER1_ET1_INIT     8
// <o.6..7> ʱ1 жȼ
// <i>  ʱ1 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define TIMER1_IP0_INIT      0
// <o.4..5>  ʱ1ʽ
// <i>  ע⣺ʽ 3 ʱ T0 ռ T1  TR1TF1 жԴ, TR1  T0 ռãʱҪر T1ɽ T1 Ϊʽ 3
// <0=> ʽ0 16 λװضʱ/
// <1=> ʽ1 16 λʱ/
// <2=> ʽ2 8 λԶװֵʱ/
#define TIMER1_M1_INIT     0
// <o.4>  ʱ1ʱԴ
// <i>  ʱϵͳʱԴƵѡλ
// <0=> ʱ1 ʱΪ Fosc /12
// <1=> ʱ1 ʱΪ Fosc
#define TIMER1_T1X12_INIT           0
// <h> ʱ1ſ
// <o.6>  ʱ1п
// <0=> ֹͣ ʱ1 
// <1=>  ʱ1 
#define TIMER1_TR1_INIT           64
// <o.7>  ʱ1ſλ
// <0=> ֻ TR1  Tx
// <1=> ֻ INT1 ˿ڵƽΪߵƽʱ TR0  1ʱ1 Ź
#define TIMER1_GATE1_INIT           0
// </h>
// <e.5> ʱ1Ƚ
#define TIMER1_T1OUT_INIT                0
// <o>  ʱ1ӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define TIMER1_T1MAP_INIT      0x00
// </e>
// <h> ʱ1ʱ
// <o> ߰λ<0-255>
#define TIMER1_TH1_INIT      0xFA
// <o> Ͱλ<0-255>
#define TIMER1_TL1_INIT      0xCB
// </h>
/******************************************* ʱ1 ʧ ******************************************/
#else
#define TIMER1_CT1_INIT        0
#define TIMER1_ET1_INIT        0
#define TIMER1_M1_INIT         0
#define TIMER1_IP0_INIT        0
#define TIMER1_T1X12_INIT      0
#define TIMER1_TR1_INIT        0
#define TIMER1_GATE1_INIT      0
#define TIMER1_T1OUT_INIT      0
#define TIMER1_T1MAP_INIT      0
#define TIMER1_TL1_INIT        0x00
#define TIMER1_TH1_INIT        0x00
#endif
// </e>
/*************************************** ʱ3  ************************************************/
// <e> ʱ3
// <i>  ʱ3
#define TIMER3_INIT_ENABLE          0
/*************************************** ʱ3ʹ ***********************************************/
#if TIMER3_INIT_ENABLE
// <o.1> ʱ3 жϿ
// <0=> ر
// <1=> 
#define TIMER3_ET3_INIT     2
// <o.6>  ʱ3
// <0=> ֹ
// <1=> 
#define TIMER3_T3PD_INIT           64
// <o.0..1>  ʱ3ʱԴ
// <i>  ʱʱԴѡ
// <0=> ϵͳʱ Fosc
// <1=> T3 ˿ⲿʱ
// <2=> ⲿƵ 32.768KHz
// <3=> ϵͳʱ Fosc 
#define TIMER3_T3CLKS_INIT           0

// <o.4..5>  ʱ3ʱԤƵ
// <i>  ʱ 3 ԤƵѡλ
// <0=> 1Ƶ
// <1=> 8Ƶ
// <2=> 64Ƶ
// <3=> 256Ƶ
#define TIMER3_T3PS_INIT           0

// <o.2>  ʱ3п
// <0=> ֹͣ ʱ3 
// <1=>  ʱ3 
#define TIMER3_TR3_INIT           0

// <o.2..3> ʱ3 жȼ
// <i>  ʱ3 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define TIMER3_IP2_INIT      0

// <h> ʱ3ʱ
// <o> ߰λ<0-255>
#define TIMER3_TH3_INIT      255
// <o> Ͱλ<0-255>
#define TIMER3_TL3_INIT      255
// </h>

// <e.1> ʱ3 ӳ
#define TIMER3_T3MAP_ENABLE                0
// <o>  
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define TIMER3_T3MAP_INIT      0x10
// </e>
/*************************************** ʱ3 ʧ ***********************************************/
#else
#define TIMER3_ET3_INIT           0
#define TIMER3_IP2_INIT           0
#define TIMER3_T3PD_INIT          0
#define TIMER3_T3CLKS_INIT        0
#define TIMER3_T3PS_INIT          0
#define TIMER3_TR3_INIT           0
#define TIMER3_TH3_INIT           0
#define TIMER3_TL3_INIT           0
#define TIMER3_T3CLKSIN_INIT      0
#define TIMER3_T3MAP_INIT         0
#endif
// </e>
/*************************************** ʱ4  ************************************************/
// <e> ʱ4
// <i>  ʱ4
#define TIMER4_INIT_ENABLE                      0
/*************************************** ʱ4 ʹ ***********************************************/
#if TIMER4_INIT_ENABLE
// <o.2> ʱ4 жϿ
// <0=> ر
// <1=> 
#define TIMER4_ET4_INIT     4
// <o.2..3>  ʱ4ʽ
// <0=> ʽ0 16 λװضʱ
// <1=> ʽ1 UART1 ʷ
// <2=> ʽ2 T4 ˿شֻϵͳʱӣT4CLKS Ч
// <3=> ʽ3 T4 ˿½شֻϵͳʱӣT4CLKS Ч
#define TIMER4_T4M_INIT     12
// <o.6>  ʱ4ȽϹ
// <0=> ֹ
// <1=> 
#define TIMER4_TC4_INIT           64
// <o.4..5>  ʱ4ʱԤƵ
// <i>  ʱ 4 ԤƵѡλ
// <0=> 1Ƶ
// <1=> 8Ƶ
// <2=> 64Ƶ
// <3=> 256Ƶ
#define TIMER4_T4PS_INIT           48
// <o.0>  ʱ4ʱԴ
// <i>  ʱʱԴѡ
// <0=> ϵͳʱ Fosc
// <1=> T4 ˿ⲿʱ
#define TIMER4_T4CLKS_INIT           0
// <o.1>  ʱ4п
// <0=> ֹͣ ʱ4 
// <1=>  ʱ4 
#define TIMER4_TR4_INIT           2
// <o.4..5> ʱ4 жȼ
// <i>  ʱ4 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define TIMER4_IP2_INIT      48
// <h> ʱ4ʱ
// <o> ߰λ<0-255>
#define TIMER4_TH4_INIT      11
// <o> Ͱλ<0-255>
#define TIMER4_TL4_INIT      220
// </h>
// <e.0> T4 ⲿ˿ӳ
#define TIMER4_T4CLKSIN_INIT                1
// <o>  ʱ4ӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define TIMER4_T4MAP_INIT      0x11
// </e>
/*************************************** ʱ4 ʧ ***********************************************/
#else
#define TIMER4_ET4_INIT           0
#define TIMER4_IP2_INIT           0
#define TIMER4_T4PD_INIT          0
#define TIMER4_T4CLKS_INIT        0
#define TIMER4_T4PS_INIT          0
#define TIMER4_TR4_INIT           0
#define TIMER4_TH4_INIT           0
#define TIMER4_TL4_INIT           0
#define TIMER4_T4CLKSIN_INIT      0
#define TIMER4_T4MAP_INIT         0
#define TIMER4_T4M_INIT           0
#define TIMER4_TC4_INIT           0
#endif
// </e>
/*************************************** ʱ5  ************************************************/
// <e> ʱ5
// <i>  ʱ5
#define TIMER5_INIT_ENABLE                      0
/*************************************** ʱ5 ʹ ***********************************************/
#if TIMER5_INIT_ENABLE
// <o.2..3>  ʱ5ʽ
// <0=> ʽ0 16 λװضʱ
// <1=> ʽ1 UART2 ʷ
// <2=> ʽ2 16 λز
// <3=> ʽ3 16 λ½ز
#define TIMER5_T5M_INIT     0
// <o.0>  T5 ϵⲿ¼/񴥷
// <0=> ֹ
// <1=> 
#define TIMER5_EXEN5_INIT           0
// <o.4> ʱ5 жϿ
// <0=> ر
// <1=> 
#define TIMER5_ET5_INIT     0
// <o.0..1> ʱ5 жȼ
// <i>  ʱ5 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define TIMER5_IP3_INIT      0
// <o.4..5>  ʱ5ʱԤƵ
// <i>  ʱ 5 ԤƵѡλ
// <0=> 1Ƶ
// <1=> 8Ƶ
// <2=> 64Ƶ
// <3=> 256Ƶ
#define TIMER5_T5PS_INIT           0
// <o.1>  ʱ5п
// <0=> ֹͣ ʱ5 
// <1=>  ʱ5 
#define TIMER5_TR5_INIT           0
// <o.0..1> ʱ5
// <i>  ʱ 5 ԤƵѡλ
// <0=> T5 ŵı仯
// <1=> ڲƵ RCŹļʱ
// <2=> UART1  RXD1 
// <3=> UART2  RXD2 
#define TIMER5_CAPM_INIT           0
// <h> ʱ5ʱ
// <o> ߰λ<0-255>
#define TIMER5_TH5_INIT      255
// <o> Ͱλ<0-255>
#define TIMER5_TL5_INIT      255
// </h>
// <e.0> ʱ5ӳ
#define TIMER5_T5MAP_ENABLE                0
// <o>  
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define TIMER5_T5MAP_INIT      0x00
// </e>
/*************************************** ʱ5 ʧ ***********************************************/
#else
#define TIMER5_T5M_INIT                  0
#define TIMER5_EXEN5_INIT                0
#define TIMER5_ET5_INIT                  0
#define TIMER5_IP3_INIT                  0
#define TIMER5_T5PS_INIT                 0
#define TIMER5_TR5_INIT                  0
#define TIMER5_CAPM_INIT                 0
#define TIMER5_TH5_INIT                  0
#define TIMER5_TL5_INIT                  0
#define TIMER5_T5MAP_INIT                0
#endif
// </e>


/*************************************** PWM ģ ************************************************/
// <e> PWM ģ
// <i>  PWM
#define PWM_INIT_ENABLE                       0
/*************************************** PWM ģʹ ************************************************/
#if PWM_INIT_ENABLE
/*************************************** PWM0 ģ ************************************************/
// <e> PWM0 ģ
// <i>  PWM0
#define PWM0_INIT_ENABLE                      1
/*************************************** PWM0 ģʹ ***********************************************/
#if PWM0_INIT_ENABLE
// <e.4>PWM0 ģϼ
#define PWM0EN_EFLT0_INIT                      16
/*************************************** PWM0 ģϼʹ ***********************************************/
#if PWM0EN_EFLT0_INIT
// <o.4>ϼ
// <0=> FLT0 Ϊ͵ƽʱPWM ر
// <1=> FLT0 ΪߵƽʱPWM ر
#define PWM0C_FLT0C_INIT                      16
// <o.5..6>Ԥ״̬ѡ
// <0=> PWM0&PWM01ڼΪ͵ƽ
// <1=> PWM0ڼ͵ƽ PWM01ڼߵƽ
// <2=> PWM0ڼߵƽ PWM01ڼ͵ƽ
// <3=> PWM0&PWM01ڼΪߵƽ
#define PWM0EN_FLT0_MODE_INIT                      96
// </e>
/*************************************** PWM0 ģϼʧ ***********************************************/
#else 
#define PWM0C_FLT0C_INIT                      0
#define PWM0EN_FLT0_MODE_INIT                      0
#endif

// <o.3>PWM0 ģ鹤ģʽ
// <i>  ע⣺޸ PWM0 ģ鹤ģʽʱȹر PWM0 ģ顣
// <0=> PWM0&PWM01 ڻģʽ
// <1=> PWM0&PWM01 ڶģʽ
#define PWM0EN_PWM0M_INIT                      8
// <o.2..3>PWM0 ģģʽ
// <0=> PWM0PWM01ΪЧ
// <1=> PWM0ΪЧPWM01ΪЧ
// <2=> PWM0ΪЧPWM01ΪЧ
// <3=> PWM0  PWM01 ΪЧ
#define PWM0C_PWM0S_INIT                      0
// <o.0..1>PWM0 ģʱԴ
// <0=> Fosc /1
// <1=> Fosc /8
// <2=> Fosc /32
// <3=> Fosc /128
#define PWM0C_CK0_INIT                      1
// <h> PWM0 ģ
// <o> ߰λ<0-255>
#define PWM0PH_INIT      3
// <o> Ͱλ<0-255>
#define PWM0PL_INIT      255
// </h>
/*************************************** PWM0  ***********************************************/
// <e> PWM0 
// <i>  PWM0
#define PWM0OUT_INIT_ENABLE                      1
/*************************************** PWM0 ʹ ***********************************************/
#if PWM0OUT_INIT_ENABLE
// <o>  PWM0 ӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define PWM0_PWM0MAP_INIT      0x22
// <h> PWM0 ռձ
// <o> ߰λ<0-255>
#define PWM0DH_INIT      15
// <o> Ͱλ<0-255>
#define PWM0DL_INIT      155
// </h>
// <o.1>PWM0 
// <0=> ֹ PWM0 
// <1=>  PWM0 
#define PWM0EN_PWM0_OEN_INIT                      0
// </e>
/*************************************** PWM0 ʧ ***********************************************/
#else
#define PWM0_PWM0MAP_INIT                         0x37
#define PWM0DH_INIT                               0
#define PWM0DL_INIT                               0
#define PWM0EN_PWM0_OEN_INIT                      0
#endif

// <e> PWM01 
// <i>  PWM01
#define PWM01OUT_INIT_ENABLE                      1
#if PWM01OUT_INIT_ENABLE
/*************************************** PWM01 ʹ ***********************************************/
// <o>  PWM01 ӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define PWM0_PWM01MAP_INIT      0x23
// <h> PWM01 ռձ
// <o> ߰λ<0-255>
#define PWM01DH_INIT      1
// <o> Ͱλ<0-255>
#define PWM01DL_INIT      55
// </h>
// <o.2>PWM01 
// <0=> ֹ PWM01 
// <1=>  PWM01 
#define PWM0EN_PWM01_OEN_INIT                      4
// </e>
/*************************************** PWM01 ʧ ***********************************************/
#else
#define PWM0_PWM01MAP_INIT          0x37
#define PWM01DH_INIT                0
#define PWM01DL_INIT                0
#define PWM0EN_PWM01_OEN_INIT       0
#endif

/*************************************** PWM0 ģ ***********************************************/
// <e> PWM0 ģ
#define PWM0_DTHL_ENABLE                      0
/*************************************** PWM0 ģʹ ***********************************************/
#if PWM0_DTHL_ENABLE
// <o> ߰λ<0-255>
#define PWM0DTH_INIT      0
// <o> Ͱλ<0-255>
#define PWM0DTL_INIT      0
// </e>
/*************************************** PWM0 ģʧ ***********************************************/
#else
#define PWM0DTH_INIT      0
#define PWM0DTL_INIT      0
#endif
// <o.0>PWM0 ģʹ
// <0=> ر PWM0 ģ
// <1=>  PWM0 ģ飨¼
#define PWM0EN_PWM0_EN_INIT                      1
// <o.7>PWM0 жϿ
// <0=> ֹ PWM0 ж
// <1=>  PWM0 ж
#define PWM0C_PWM0IE_INIT                      0
/*************************************** PWM0 ʧ ***********************************************/
#else
#define PWM0EN_EFLT0_INIT                      0
#define PWM0C_FLT0C_INIT                       0
#define PWM0EN_FLT0_MODE_INIT                  0
#define PWM0EN_PWM0M_INIT                      0
#define PWM0C_PWM0S_INIT                       0
#define PWM0C_CK0_INIT                         0
#define PWM0PH_INIT                            255
#define PWM0PL_INIT                            255
#define PWM0OUT_INIT_ENABLE                    0
#define PWM0_PWM0MAP_INIT                      0x37
#define PWM0DH_INIT                            0
#define PWM0DL_INIT                            0
#define PWM0EN_PWM0_OEN_INIT                   0
#define PWM01OUT_INIT_ENABLE                   0
#define PWM0_PWM01MAP_INIT                     0x37
#define PWM01DH_INIT                           0
#define PWM01DL_INIT                           0
#define PWM0EN_PWM01_OEN_INIT                  0
#define PWM0_DTHL_ENABLE                       0
#define PWM0DTH_INIT                           0
#define PWM0DTL_INIT                           0
#define PWM0EN_PWM0_EN_INIT                    0
#define PWM0C_PWM0IE_INIT                      0
#endif
// </e>

/*************************************** PWM1 ģ ************************************************/
// <e> PWM1 ģ
// <i>  PWM1
#define PWM1_INIT_ENABLE                      0
/*************************************** PWM1 ģʹ ***********************************************/
#if PWM1_INIT_ENABLE
// <e.4>PWM1 ģϼ
#define PWM1EN_EFLT0_INIT                      16
/*************************************** PWM1 ģϼʹ ***********************************************/
#if PWM1EN_EFLT0_INIT
// <o.4>ϼ
// <0=> FLT0 Ϊ͵ƽʱPWM ر
// <1=> FLT0 ΪߵƽʱPWM ر
#define PWM1C_FLT0C_INIT                      16
// <o.5..6>Ԥ״̬ѡ
// <0=> PWM1&PWM11ڼΪ͵ƽ
// <1=> PWM1ڼ͵ƽ PWM11ڼߵƽ
// <2=> PWM1ڼߵƽ PWM11ڼ͵ƽ
// <3=> PWM1&PWM11ڼΪߵƽ
#define PWM1EN_FLT0_MODE_INIT                      0
// </e>
/*************************************** PWM1 ģϼ ʧ ***********************************************/
#else 
#define PWM1C_FLT0C_INIT                      0
#define PWM1EN_FLT0_MODE_INIT                      0
#endif

// <o.3>PWM1 ģ鹤ģʽ
// <i>  ע⣺޸ PWM1 ģ鹤ģʽʱȹر PWM1 ģ顣
// <0=> PWM1&PWM11 ڻģʽ
// <1=> PWM1&PWM11 ڶģʽ
#define PWM1EN_PWM1M_INIT                      8
// <o.2..3>PWM1 ģģʽ
// <0=> PWM1PWM11ΪЧ
// <1=> PWM1ΪЧPWM11ΪЧ
// <2=> PWM1ΪЧPWM11ΪЧ
// <3=> PWM1  PWM11 ΪЧ
#define PWM1C_PWM1S_INIT                      0
// <o.0..1>PWM1 ģʱԴ
// <0=> Fosc /1
// <1=> Fosc /8
// <2=> Fosc /32
// <3=> Fosc /128
#define PWM1C_CK0_INIT                      1
// <h> PWM1 ģ
// <o> ߰λ<0-255>
#define PWM1PH_INIT      3
// <o> Ͱλ<0-255>
#define PWM1PL_INIT      255
// </h>
/*************************************** PWM1  ***********************************************/
// <e> PWM1 
// <i>  PWM1
#define PWM1OUT_INIT_ENABLE                      1
/*************************************** PWM1 ʹ ***********************************************/
#if PWM1OUT_INIT_ENABLE
// <o>  PWM1 ӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define PWM1_PWM1MAP_INIT      0x22
// <h> PWM1 ռձ
// <o> ߰λ<0-255>
#define PWM1DH_INIT      128
// <o> Ͱλ<0-255>
#define PWM1DL_INIT      255
// </h>
// <o.1>PWM1 
// <0=> ֹ PWM1 
// <1=>  PWM1 
#define PWM1EN_PWM1_OEN_INIT                      2
// </e>
/*************************************** PWM1 ʧ ***********************************************/
#else
#define PWM1_PWM1MAP_INIT                         0x37
#define PWM1DH_INIT                               0
#define PWM1DL_INIT                               0
#define PWM1EN_PWM1_OEN_INIT                      0
#endif

// <e> PWM11 
// <i>  PWM11
#define PWM11OUT_INIT_ENABLE                      1
#if PWM11OUT_INIT_ENABLE
/*************************************** PWM11 ʹ ***********************************************/
// <o>  PWM11 ӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define PWM1_PWM11MAP_INIT      0x23
// <h> PWM11 ռձ
// <o> ߰λ<0-255>
#define PWM11DH_INIT      1
// <o> Ͱλ<0-255>
#define PWM11DL_INIT      85
// </h>
// <o.2>PWM11 
// <0=> ֹ PWM11 
// <1=>  PWM11 
#define PWM1EN_PWM11_OEN_INIT                      4
// </e>
/*************************************** PWM11 ʧ ***********************************************/
#else
#define PWM1_PWM11MAP_INIT          0x37
#define PWM11DH_INIT                0
#define PWM11DL_INIT                0
#define PWM1EN_PWM11_OEN_INIT       0
#endif

/*************************************** PWM1 ģ ***********************************************/
// <e> PWM1 ģ
#define PWM1_DTHL_ENABLE                      0
/*************************************** PWM1 ģʹ ***********************************************/
#if PWM1_DTHL_ENABLE
// <o> ߰λ<0-255>
#define PWM1DTH_INIT      0
// <o> Ͱλ<0-255>
#define PWM1DTL_INIT      0
// </e>
/*************************************** PWM1 ģʧ ***********************************************/
#else
#define PWM1DTH_INIT      0
#define PWM1DTL_INIT      0
#endif
// <o.0>PWM1 ģʹ
// <0=> ر PWM1 ģ
// <1=>  PWM1 ģ飨¼
#define PWM1EN_PWM1_EN_INIT                      1
// <o.7>PWM1 жϿ
// <0=> ֹ PWM1 ж
// <1=>  PWM1 ж
#define PWM1C_PWM1IE_INIT                      0
/*************************************** PWM1 ʧ ***********************************************/
#else
#define PWM1EN_EFLT0_INIT                      0
#define PWM1C_FLT0C_INIT                       0
#define PWM1EN_FLT0_MODE_INIT                  0
#define PWM1EN_PWM1M_INIT                      0
#define PWM1C_PWM1S_INIT                       0
#define PWM1C_CK0_INIT                         0
#define PWM1PH_INIT                            255
#define PWM1PL_INIT                            255
#define PWM1OUT_INIT_ENABLE                    0
#define PWM1_PWM1MAP_INIT                      0x37
#define PWM1DH_INIT                            0
#define PWM1DL_INIT                            0
#define PWM1EN_PWM1_OEN_INIT                   0
#define PWM11OUT_INIT_ENABLE                   0
#define PWM1_PWM11MAP_INIT                     0x37
#define PWM11DH_INIT                           0
#define PWM11DL_INIT                           0
#define PWM1EN_PWM11_OEN_INIT                  0
#define PWM1_DTHL_ENABLE                       0
#define PWM1DTH_INIT                           0
#define PWM1DTL_INIT                           0
#define PWM1EN_PWM1_EN_INIT                    0
#define PWM1C_PWM1IE_INIT                      0
#endif
// </e>

/*************************************** PWM2 ģ ************************************************/
// <e> PWM2 ģ
// <i>  PWM2
#define PWM2_INIT_ENABLE                      0
/*************************************** PWM2 ģʹ ***********************************************/
#if PWM2_INIT_ENABLE
// <e.4>PWM2 ģϼ
#define PWM2EN_EFLT0_INIT                      0
/*************************************** PWM2 ģϼʹ ***********************************************/
#if PWM2EN_EFLT0_INIT
// <o.4>ϼ
// <0=> FLT0 Ϊ͵ƽʱPWM ر
// <1=> FLT0 ΪߵƽʱPWM ر
#define PWM2C_FLT0C_INIT                      16
// <o.5..6>Ԥ״̬ѡ
// <0=> PWM2&PWM21ڼΪ͵ƽ
// <1=> PWM2ڼ͵ƽ PWM21ڼߵƽ
// <2=> PWM2ڼߵƽ PWM21ڼ͵ƽ
// <3=> PWM2&PWM21ڼΪߵƽ
#define PWM2EN_FLT0_MODE_INIT                      0
// </e>
/*************************************** PWM2 ģϼʧ ***********************************************/
#else 
#define PWM2C_FLT0C_INIT                      0
#define PWM2EN_FLT0_MODE_INIT                      0
#endif

// <o.3>PWM2 ģ鹤ģʽ
// <i>  ע⣺޸ PWM2 ģ鹤ģʽʱȹر PWM2 ģ顣
// <0=> PWM2&PWM21 ڻģʽ
// <1=> PWM2&PWM21 ڶģʽ
#define PWM2EN_PWM2M_INIT                      8
// <o.2..3>PWM2 ģģʽ
// <0=> PWM2PWM21ΪЧ
// <1=> PWM2ΪЧPWM21ΪЧ
// <2=> PWM2ΪЧPWM21ΪЧ
// <3=> PWM2  PWM21 ΪЧ
#define PWM2C_PWM2S_INIT                      0
// <o.0..1>PWM2 ģʱԴ
// <0=> Fosc /1
// <1=> Fosc /8
// <2=> Fosc /32
// <3=> Fosc /128
#define PWM2C_CK0_INIT                      1
// <h> PWM2 ģ
// <o> ߰λ<0-255>
#define PWM2PH_INIT      3
// <o> Ͱλ<0-255>
#define PWM2PL_INIT      255
// </h>
/*************************************** PWM2  ***********************************************/
// <e> PWM2 
// <i>  PWM2
#define PWM2OUT_INIT_ENABLE                      1
/*************************************** PWM2 ʹ ***********************************************/
#if PWM2OUT_INIT_ENABLE
// <o>  PWM2 ӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define PWM2_PWM2MAP_INIT      0x00
// <h> PWM2 ռձ
// <o> ߰λ<0-255>
#define PWM2DH_INIT      1
// <o> Ͱλ<0-255>
#define PWM2DL_INIT      85
// </h>
// <o.1>PWM2 
// <0=> ֹ PWM2 
// <1=>  PWM2 
#define PWM2EN_PWM2_OEN_INIT                      2
// </e>
/*************************************** PWM2 ʧ ***********************************************/
#else
#define PWM2_PWM2MAP_INIT                         0x37
#define PWM2DH_INIT                               0
#define PWM2DL_INIT                               0
#define PWM2EN_PWM2_OEN_INIT                      0
#endif

// <e> PWM21 
// <i>  PWM21
#define PWM21OUT_INIT_ENABLE                      1
#if PWM21OUT_INIT_ENABLE
/*************************************** PWM21 ʹ ***********************************************/
// <o>  PWM21 ӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define PWM2_PWM21MAP_INIT      0x01
// <h> PWM21 ռձ
// <o> ߰λ<0-255>
#define PWM21DH_INIT      1
// <o> Ͱλ<0-255>
#define PWM21DL_INIT      85
// </h>
// <o.2>PWM21 
// <0=> ֹ PWM21 
// <1=>  PWM21 
#define PWM2EN_PWM21_OEN_INIT                      4
// </e>
/*************************************** PWM21 ʧ ***********************************************/
#else
#define PWM2_PWM21MAP_INIT          0x37
#define PWM21DH_INIT                0
#define PWM21DL_INIT                0
#define PWM2EN_PWM21_OEN_INIT       0
#endif

/*************************************** PWM2 ģ ***********************************************/
// <e> PWM2 ģ
#define PWM2_DTHL_ENABLE                      0
/*************************************** PWM2 ģʹ ***********************************************/
#if PWM2_DTHL_ENABLE
// <o> ߰λ<0-255>
#define PWM2DTH_INIT      0
// <o> Ͱλ<0-255>
#define PWM2DTL_INIT      0
// </e>
/*************************************** PWM2 ģʧ ***********************************************/
#else
#define PWM2DTH_INIT      0
#define PWM2DTL_INIT      0
#endif
// <o.0>PWM2 ģʹ
// <0=> ر PWM2 ģ
// <1=>  PWM2 ģ飨¼
#define PWM2EN_PWM2_EN_INIT                      1
// <o.7>PWM2 жϿ
// <0=> ֹ PWM2 ж
// <1=>  PWM2 ж
#define PWM2C_PWM2IE_INIT                      0
/*************************************** PWM2 ʧ ***********************************************/
#else
#define PWM2EN_EFLT0_INIT                      0
#define PWM2C_FLT0C_INIT                       0
#define PWM2EN_FLT0_MODE_INIT                  0
#define PWM2EN_PWM2M_INIT                      0
#define PWM2C_PWM2S_INIT                       0
#define PWM2C_CK0_INIT                         0
#define PWM2PH_INIT                            255
#define PWM2PL_INIT                            255
#define PWM2OUT_INIT_ENABLE                    0
#define PWM2_PWM2MAP_INIT                      0x37
#define PWM2DH_INIT                            0
#define PWM2DL_INIT                            0
#define PWM2EN_PWM2_OEN_INIT                   0
#define PWM21OUT_INIT_ENABLE                   0
#define PWM2_PWM21MAP_INIT                     0x37
#define PWM21DH_INIT                           0
#define PWM21DL_INIT                           0
#define PWM2EN_PWM21_OEN_INIT                  0
#define PWM2_DTHL_ENABLE                       0
#define PWM2DTH_INIT                           0
#define PWM2DTL_INIT                           0
#define PWM2EN_PWM2_EN_INIT                    0
#define PWM2C_PWM2IE_INIT                      0
// </e>
#endif

/*************************************** PWM3 ģ ************************************************/
// <e> PWM3 ģ
// <i>  PWM3
#define PWM3_INIT_ENABLE                      0
#if PWM3_INIT_ENABLE 
// <o.3>PWM3 ģģʽ
// <0=> PWM3 ЧڼΪߵƽ
// <3=> PWM3 ЧڼΪ͵ƽ
#define PWM3C_PWM3S_INIT                      0
// <o.0..2>PWM3 ģʱԴ
// <0=> Fosc /1
// <1=> Fosc /2
// <2=> Fosc /4
// <3=> Fosc /8
// <4=> Fosc /16
// <5=> Fosc /32
// <6=> Fosc /64
// <7=> Fosc /128
#define PWM3C_PTCK3_INIT                      2
// <o.6>PWM3 жϿ
// <0=> ֹ PWM3 ж
// <1=>  PWM3 ж
#define PWM3C_PWM3IE_INIT                      0
// <o.4>PWM3 
// <0=> ֹ
// <1=> 
#define PWM3C_PWM3OEN_INIT                      16
// <o>  PWM3 ӳ
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define PWM3_PWM3MAP_INIT      0
// <o.7>PWM3 ģʹ
// <0=> ر PWM3 ģ
// <1=>  PWM3 ģ飨¼
#define PWM3C_PWM3EN_INIT                      128
// <o> PWM3 ģ<0-255>
#define PWM3P_INIT      255
// <o> PWM3 ģռձ<0-255>
#define PWM3D_INIT      85
/*************************************** PWM3 ʧ ***********************************************/
#else
#define PWM3C_PWM3S_INIT                      0
#define PWM3C_PTCK3_INIT                      0
#define PWM3C_PWM3OEN_INIT                     0
#define PWM3C_PWM3IE_INIT                     0
#define PWM3C_PWM3EN_INIT                   0
#define PWM3P_INIT                            0
#define PWM3D_INIT                            0
// </e>
#endif
// <o.6..7> PWM жȼ
// <i>  PWM жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define PWM_IP2_INIT      0
/*************************************** PWM ģʧ ************************************************/
#else 
#define PWM0_INIT_ENABLE                       0
#define PWM0EN_EFLT0_INIT                      0
#define PWM0C_FLT0C_INIT                       0
#define PWM0EN_FLT0_MODE_INIT                  0
#define PWM0EN_PWM0M_INIT                      0
#define PWM0C_PWM0S_INIT                       0
#define PWM0C_CK0_INIT                         0
#define PWM0PH_INIT                            255
#define PWM0PL_INIT                            255
#define PWM0OUT_INIT_ENABLE                    0
#define PWM0_PWM0MAP_INIT                      0x37
#define PWM0DH_INIT                            0
#define PWM0DL_INIT                            0
#define PWM0EN_PWM0_OEN_INIT                   0
#define PWM01OUT_INIT_ENABLE                   0
#define PWM0_PWM01MAP_INIT                     0x37
#define PWM01DH_INIT                           0
#define PWM01DL_INIT                           0
#define PWM0EN_PWM01_OEN_INIT                  0
#define PWM0_DTHL_ENABLE                       0
#define PWM0DTH_INIT                           0
#define PWM0DTL_INIT                           0
#define PWM0EN_PWM0_EN_INIT                    0
#define PWM0C_PWM0IE_INIT                      0

#define PWM1_INIT_ENABLE                       0
#define PWM1EN_EFLT0_INIT                      0
#define PWM1C_FLT0C_INIT                       0
#define PWM1EN_FLT0_MODE_INIT                  0
#define PWM1EN_PWM1M_INIT                      0
#define PWM1C_PWM1S_INIT                       0
#define PWM1C_CK0_INIT                         0
#define PWM1PH_INIT                            255
#define PWM1PL_INIT                            255
#define PWM1OUT_INIT_ENABLE                    0
#define PWM1_PWM1MAP_INIT                      0x37
#define PWM1DH_INIT                            0
#define PWM1DL_INIT                            0
#define PWM1EN_PWM1_OEN_INIT                   0
#define PWM11OUT_INIT_ENABLE                   0
#define PWM1_PWM11MAP_INIT                     0x37
#define PWM11DH_INIT                           0
#define PWM11DL_INIT                           0
#define PWM1EN_PWM11_OEN_INIT                  0
#define PWM1_DTHL_ENABLE                       0
#define PWM1DTH_INIT                           0
#define PWM1DTL_INIT                           0
#define PWM1EN_PWM1_EN_INIT                    0
#define PWM1C_PWM1IE_INIT                      0

#define PWM2_INIT_ENABLE                       0
#define PWM2EN_EFLT0_INIT                      0
#define PWM2C_FLT0C_INIT                       0
#define PWM2EN_FLT0_MODE_INIT                  0
#define PWM2EN_PWM2M_INIT                      0
#define PWM2C_PWM2S_INIT                       0
#define PWM2C_CK0_INIT                         0
#define PWM2PH_INIT                            255
#define PWM2PL_INIT                            255
#define PWM2OUT_INIT_ENABLE                    0
#define PWM2_PWM2MAP_INIT                      0x37
#define PWM2DH_INIT                            0
#define PWM2DL_INIT                            0
#define PWM2EN_PWM2_OEN_INIT                   0
#define PWM21OUT_INIT_ENABLE                   0
#define PWM2_PWM21MAP_INIT                     0x37
#define PWM21DH_INIT                           0
#define PWM21DL_INIT                           0
#define PWM2EN_PWM21_OEN_INIT                  0
#define PWM2_DTHL_ENABLE                       0
#define PWM2DTH_INIT                           0
#define PWM2DTL_INIT                           0
#define PWM2EN_PWM2_EN_INIT                    0
#define PWM2C_PWM2IE_INIT                      0

#define PWM3_INIT_ENABLE                      0
#define PWM3C_PWM3S_INIT                      0
#define PWM3C_PTCK3_INIT                      0
#define PWM3C_PWM3OEN_INIT                    0
#define PWM3C_PWM3IE_INIT                     0
#define PWM3C_PWM3EN_INIT                     0
#define PWM3P_INIT                            0
#define PWM3D_INIT                            0

#define PWM_IP2_INIT                           0

#endif
// </e>



/*************************************** ADC  ************************************************/
//<e>ADC
// <i>  ADC
#define ADC_INIT_ENABLE                      0
#if ADC_INIT_ENABLE

// <q.7>ADC ģԴʹ
#define ADCC0_ADCEN_INIT                      128

// <e>ADC ж
#define ADC_INT_ENABLE                    0
#if ADC_INT_ENABLE
// <o.5> ADC жϿ
// <0=> ر
// <1=> 
#define ADC_EADC_INIT     32
// <o.2..3> ADC жȼ
// <i>  ADC жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define ADC_IP3_INIT      4
//</e>
#else
#define ADC_EADC_INIT     0
#define ADC_IP3_INIT      0

#endif



// <q.6>ADC ת
#define ADCC0_ADCST_INIT                      64

// <e.2>ڲ VREF 
#define ADCC0_VREFS_INIT                      4
// <o.0..1> ڲ׼ѹԴѡ
// <i> ڲοѹѡΪ2V ʱ VDD ѹ 2.7Vڲοѹѡ 3/4V ʱ VDD ڲοѹ 0.5V ϡ
// <i> ϵͳģʽǰ齫 ADC οѹѡ VDDԽһϵͳġ
// <0=> VDDź
// <1=> ڲ4V
// <2=> ڲ3V
// <3=> ڲ2V
#define ADCC0_INREF_S_INIT                    2
// <q.3>Vref 
#define ADCC0_VREFO_INIT                      0
//</e>

// <o> ADCͨѡ
// <0x4F=> ڲVDD/4ź
// <0xCF=> ڲGNDź
// <0=> ⲿͨ0
// <1=> ⲿͨ1
// <2=> ⲿͨ2
// <3=> ⲿͨ3
// <4=> ⲿͨ4
// <5=> ⲿͨ5
// <6=> ⲿͨ6
// <7=> ⲿͨ7
// <8=> ⲿͨ8
// <9=> ⲿͨ9
// <10=> ⲿͨ10
#define ADCC1_INIT                      0

// <o.6..7> ADCתݳ
// <0=> 12 λ(߰λλ)
// <1=> 12 λ(λͰλ)
// <2=> 10 λ(߰λͶλ)
// <3=> 10 λ(߶λͰλ)
#define ADCC2_ADCL_ALIGN_INIT                      64

// <o.3..5> ADCתʱ
// <i> Ϊ˱֤ȣADCתҪ
// <0=> ADCʱƵ4MHZ
// <1=> ADCʱƵ1MHZ/2MHZ
// <3=> ADCʱƵС1MHZ
#define ADCC2_ADCTS_INIT                      0

// <o.0..2> ADC ʱ
// <0=> Fosc /2
// <1=> Fosc /4
// <2=> Fosc /6
// <3=> Fosc /8
// <4=> Fosc /12
// <5=> Fosc /16
// <6=> Fosc /24 
// <7=> Fosc /32
#define ADCC2_ADCS_INIT                      0

//<q.7> ADC
#define ADCWC_AMWEN_INIT                      0
//</e>
#else
#define ADC_INT_ENABLE                      0
#define ADC_EADC_INIT     0
#define ADC_IP3_INIT      0
#define ADCC0_ADCEN_INIT                      0
#define ADCC0_ADCST_INIT                      0
#define ADCC0_VREFS_INIT                      0
#define ADCC0_INREF_S_INIT                    0
#define ADCC0_VREFO_INIT                      0
#define ADCC1_INIT                      0
#define ADCC2_ADCL_ALIGN_INIT                      0
#define ADCC2_ADCTS_INIT                      0
#define ADCC2_ADCS_INIT                      0
#define ADCWC_AMWEN_INIT                      0
#endif


/*************************************** UART1  ************************************************/
//<e>UART1 
// <i>  UART1
#define UART1_INIT_ENABLE                      0
/*************************************** UART1 ģʹ ************************************************/
#if UART1_INIT_ENABLE
// <q.4>нʹܿλ
#define UART1_REN_INIT        0x00

// <e.4>UART1 ж
#define UART1_INT_ENABLE                      0
/*************************************** UART1ж ʹ ************************************************/
#if UART1_INT_ENABLE
// <o.4> UART1 жϿ
// <0=> ر
// <1=> 
#define UART1_ES1_INIT     0
// <o.0..1> UART1 жȼ
// <i>  UART1 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define UART1_IP1_INIT      0
//</e>
#else
#define UART1_ES1_INIT     0
#define UART1_IP1_INIT      0
#endif

// <o>  TXD ӳ
// <0x37=> Not Used
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define UART1_TXDMAP_INIT      1

// <o>  RXD ӳ
// <0x37=> Not Used
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define UART1_RXDMAP_INIT      0
/*************************************** UART ʽ0  ************************************************/
// <e>ʽ0
#define UART1_MODEL0_ENABLE        0x00
/*************************************** ʽ0 ʹ ************************************************/
#if UART1_MODEL0_ENABLE
// <o.5> ģʽ0 ͨٶ
// <0=> ģʽ0 ʱΪ Fosc /12
// <1=> ģʽ0 ʱΪ Fosc /2
#define UART1_MODEL0_UX6_INIT        0x00
/*************************************** ʽ0 ʧ ************************************************/
#else
#define UART1_MODEL0_UX6_INIT        0x00
#endif
// </e>
/*************************************** UART ʽ1  ************************************************/
// <e>ʽ1
#define UART1_MODEL1_ENABLE        0x00
/*************************************** ʽ1 ʹ ************************************************/
#if UART1_MODEL1_ENABLE
// <o.0> ֹͣλʹ
// <0=> ֹͣλֹͣλ 0  1 λ RI
// <1=> ֹͣλȷϼ飬ֻЧֹͣλ1λ RI
#define UART1_MODEL1_SM2_INIT        0x00
/*************************************** ʽ1 ʧ ************************************************/
#else
#define UART1_MODEL1_SM2_INIT        0x00
#endif
// </e>
/*************************************** UART ʽ2  ************************************************/
// <e>ʽ2
#define UART1_MODEL2_ENABLE        0x00
/*************************************** ʽ2 ʹ ************************************************/
#if UART1_MODEL2_ENABLE
// <o.7> ʼӱ
// <0=> Ϊϵͳʱ Fosc  1/64
// <1=> Ϊϵͳʱ Fosc  1/32
#define UART1_MODEL2_SMOD_INIT        0x00
// <e.0> ͨʹ
#define UART1_MODEL2_SM2_INIT        0x00
/*************************************** ʽ2 ͨѶʹ ************************************************/
#if UART1_MODEL2_SM2_INIT
// <o> ӻַ<0-255>
#define UART1_MODEL2_SADDR_INIT      0
// <o> ӻ<0-255>
#define UART1_MODEL2_SADEN_INIT      0
/*************************************** ʽ2 ͨѶʧ ************************************************/
#else
#define UART1_MODEL2_SADDR_INIT      0
#define UART1_MODEL2_SADEN_INIT      0
#endif
// </e>
/*************************************** ʽ2 ʧ ************************************************/
#else
#define UART1_MODEL2_SMOD_INIT        0x00
#define UART1_MODEL2_SM2_INIT         0x00
#define UART1_MODEL2_SADDR_INIT       0
#define UART1_MODEL2_SADEN_INIT       0
#endif
// </e>
/*************************************** UART ʽ3  ************************************************/
// <e>ʽ3
#define UART1_MODEL3_ENABLE        0x00
/*************************************** ʽ3 ʹ ************************************************/
#if UART1_MODEL3_ENABLE
// <e.0> ͨʹ
#define UART1_MODEL3_SM2_INIT        0x00
/*************************************** ʽ3 ͨѶʹ ************************************************/
#if UART1_MODEL3_SM2_INIT
// <o> ӻַ<0-255>
#define UART1_MODEL3_SADDR_INIT      0
// <o> ӻ<0-255>
#define UART1_MODEL3_SADEN_INIT      0
/*************************************** ʽ3 ͨѶʧ ************************************************/
#else
#define UART1_MODEL3_SADDR_INIT      0
#define UART1_MODEL3_SADEN_INIT      0
#endif
// </e>
/*************************************** ʽ3 ʧ ************************************************/
#else
#define UART1_MODEL3_SM2_INIT         0x00
#define UART1_MODEL3_SADDR_INIT       0
#define UART1_MODEL3_SADEN_INIT       0
#endif
// </e>
/*************************************** UART1 ģʧ ************************************************/
#else
#define UART1_MODEL0_ENABLE        0x00
#define UART1_MODEL1_ENABLE        0x00
#define UART1_MODEL2_ENABLE        0x00
#define UART1_MODEL3_ENABLE        0x00
#define UART1_INT_ENABLE           0

#define UART1_ES1_INIT     0
#define UART1_IP1_INIT      0
#define UART1_TXDMAP_INIT      0
#define UART1_RXDMAP_INIT      0
#define UART1_MODEL0_UX6_INIT          0x00
#define UART1_MODEL1_SM2_INIT         0x00
#define UART1_MODEL2_SMOD_INIT        0x00
#define UART1_MODEL2_SM2_INIT         0x00
#define UART1_MODEL2_SADDR_INIT       0
#define UART1_MODEL2_SADEN_INIT       0
#define UART1_MODEL3_SM2_INIT         0x00
#define UART1_MODEL3_SADDR_INIT       0
#define UART1_MODEL3_SADEN_INIT       0

#endif
//</e>


/*************************************** UART2  ************************************************/
//<e>UART2 
// <i>  UART2
#define UART2_INIT_ENABLE                      0
/*************************************** UART2 ģʹ ************************************************/
#if UART2_INIT_ENABLE
// <q.4>нʹܿλ
#define UART2_REN_INIT        0x00

// <e.0>UART2 ж
#define UART2_INT_ENABLE                      0
/*************************************** UART2ж ʹ ************************************************/
#if UART2_INT_ENABLE
// <o.6> UART2 жϿ
// <0=> ر
// <1=> 
#define UART2_ES2_INIT     0
// <o.6..7> UART2 жȼ
// <i>  UART2 жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define UART2_IP1_INIT      0
//</e>
#else
#define UART2_ES2_INIT     0
#define UART2_IP1_INIT      0
#endif

// <o>  TXD ӳ
// <0x37=> Not Used
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define UART2_TXD2MAP_INIT      1

// <o>  RXD ӳ
// <0x37=> Not Used
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define UART2_RXD2MAP_INIT      0

// <o.1>  ʽѡ
// <0x00=> 8 λ UARTʱ 5 /16 
// <0x01=> 9 λ UARTʱ 5 /16

// <o.0>  ھλʹ
// <0x00=> 
// <0x01=> 
#define UART2_S2CON2_INIT      0

/*************************************** UART2 ģʧ ************************************************/
#else
#define UART2_INT_ENABLE                      0
#define UART2_ES2_INIT     0
#define UART2_IP1_INIT      0
#define UART2_TXD2MAP_INIT     0x37
#define UART2_RXD2MAP_INIT     0x37
#define UART2_S2CON2_INIT      0
#endif
//</e>

/*************************************** SPI  ************************************************/
//<e>SPI 
// <i>  SPI
#define SPI_INIT_ENABLE                      0
/*************************************** SPI ģʹ ************************************************/
#if SPI_INIT_ENABLE
//<q.7> SS ʹλ
//<q.6> SPI ʹλ
//<o.5> ͷѡ
// <0x00=> MSBȷ
// <0x01=> LSBȷ
//<o.4> /ӻģʽѡ
// <0x00=> ӻģʽ
// <0x01=> ģʽ
//<o.3> SPI ʱӼѡ
// <0x00=> SCK ʱΪ͵ƽ
// <0x01=> SCK ʱΪߵƽ
//<o.2> SPI ʱλѡ
// <0x00=>  SPI ʱӵĵһز
// <0x01=>  SPI ʱӵĵڶز
//<o.0..1> SPI ʱѡ
// <0x00=> Fosc /4
// <0x01=> Fosc /16
// <0x02=> Fosc /64
// <0x03=> Fosc /128
#define  SPI_SPCTL_INIT  0x00

// <o>  MOSI ӳ
// <0x37=> Not Used
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define SPI_MOSIMAP_INIT      0

// <o>  MISO ӳ
// <0x37=> Not Used
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define SPI_MISOMAP_INIT      0

// <o>  SCK ӳ
// <0x37=> Not Used
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define SPI_SCKMAP_INIT      0x37

// <o>  SS ӳ
// <0x37=> Not Used
// <0x00=> P00 
// <0x01=> P01
// <0x02=> P02
// <0x03=> P03
// <0x04=> P04
// <0x05=> P05 
// <0x06=> P06
// <0x07=> P07
// <0x10=> P10
// <0x11=> P11
// <0x20=> P20 
// <0x21=> P21
// <0x22=> P22
// <0x23=> P23
// <0x24=> P24
// <0x25=> P25 
// <0x26=> P26
// <0x27=> P27
#define SPI_SSMAP_INIT      0x37



// <e.0>SPI ж
#define SPI_INT_ENABLE                      0
/*************************************** SPIж ʹ ************************************************/
#if SPI_INT_ENABLE
// <o.0> SPI жϿ
// <0=> ر
// <1=> 
#define SPI_ESPI_INIT     0
// <o.0..1> SPI жȼ
// <i>  SPI жȼ
// <0=> ȼ 0ͣ
// <1=> ȼ 1
// <2=> ȼ 2
// <3=> ȼ 3ߣ
#define SPI_IP2_INIT      0
//</e>
#else
#define SPI_ESPI_INIT     0
#define SPI_IP2_INIT      0
#endif
//</e>
#else

#define  SPI_SPCTL_INIT  0x00
#define  SPI_INT_ENABLE   0
#define  SPI_ESPI_INIT     0
#define  SPI_IP2_INIT      0
#endif
//------------- <<< end of configuration section >>> ---------------------------

#define  EXIT_INT01_PINS_INIT   (EXIT1_INT1_PINS_INIT + EXIT0_INT0_PINS_INIT)
#define  EXIT_PITS0_INIT        (EXIT0_IT0_INIT + EXIT1_IT1_INIT + EXIT2_IT2_INIT + EXIT3_IT3_INIT)
#define  EXIT_PITS1_INIT        (EXIT4_IT4_INIT + EXIT5_IT5_INIT + EXIT6_IT6_INIT + EXIT7_IT7_INIT)
#define  EXIT_PITS2_INIT        (EXIT8_IT8_INIT + EXIT9_IT9_INIT + EXIT10_IT10_INIT + EXIT11_IT11_INIT)
#define  EXIT_PITS3_INIT        (EXIT12_IT12_INIT + EXIT13_IT13_INIT + EXIT14_IT14_INIT + EXIT15_IT15_INIT)
#define  EXIT_PINTE0_INIT       (EXIT2_EINT2_INIT + EXIT3_EINT3_INIT + EXIT4_EINT4_INIT + EXIT5_EINT5_INIT \
                               + EXIT6_EINT6_INIT + EXIT7_EINT7_INIT)
#define  EXIT_PINTE1_INIT       (EXIT8_EINT8_INIT + EXIT9_EINT9_INIT + EXIT10_EINT10_INIT + EXIT11_EINT11_INIT \
                               + EXIT12_EINT12_INIT + EXIT13_EINT13_INIT + EXIT14_EINT14_INIT + EXIT15_EINT15_INIT)
#define  INT_IE_INIT            (WDT_EWT_INIT + EXIT0_EX0_INIT + EXIT1_EX1_INIT + TIMER0_ET0_INIT + TIMER1_ET1_INIT + \
                                 UART1_ES1_INIT + UART2_ES2_INIT)
#define  INT_IE1_INIT           (EXIT2_7_EX2_7_INIT + EXIT8_15_EX8_15_INIT + TIMER3_ET3_INIT + TIMER4_ET4_INIT \
                               + TIMER5_ET5_INIT + ADC_EADC_INIT + UART1_ES1_INIT+ SPI_ESPI_INIT)
#define  INT_IP0_INIT           (EXIT1_IP0_INIT + EXIT0_IP0_INIT + TIMER0_IP0_INIT + TIMER1_IP0_INIT)
#define  INT_IP1_INIT           (WDT_IP1_INIT + UART1_IP1_INIT +UART2_IP1_INIT + LVD_IP1_INIT)
#define  INT_IP2_INIT           (TIMER3_IP2_INIT + TIMER4_IP2_INIT + PWM_IP2_INIT + SPI_IP2_INIT)
#define  INT_IP3_INIT           (EXIT8_15_IP3_INIT + EXIT2_7_IP3_INIT + TIMER5_IP3_INIT + ADC_IP3_INIT)

#define  TIMER01_TCON_INIT      (TIMER0_TR0_INIT + TIMER1_TR1_INIT)
#define  TIMER01_TCON1_INIT     (TIMER0_T0OUT_INIT + TIMER0_T0X12_INIT + TIMER1_T1OUT_INIT + TIMER1_T1X12_INIT)
#define  TIMER01_TMOD_INIT      (TIMER0_GATE0_INIT + TIMER0_CT0_INIT + TIMER0_M0_INIT \
                               + TIMER1_GATE1_INIT + TIMER1_CT1_INIT + TIMER1_M1_INIT )
#define  TIMER3_TCON_INIT       (TIMER3_TR3_INIT + TIMER3_T3PD_INIT + TIMER3_T3PS_INIT + TIMER3_T3CLKS_INIT)															 
#define  TIMER4_TCON_INIT       (TIMER4_TC4_INIT + TIMER4_T4PS_INIT + TIMER4_T4M_INIT + TIMER4_TR4_INIT + TIMER4_T4CLKS_INIT)																		 
#define  TIMER5_TCON_INIT       (TIMER5_T5PS_INIT + TIMER5_T5M_INIT + TIMER5_TR5_INIT + TIMER5_EXEN5_INIT)	
#define  TIMER5_TCON1_INIT      (TIMER5_CAPM_INIT)
#define  PWM0_PWM0EN_INIT       (PWM0EN_FLT0_MODE_INIT + PWM0EN_EFLT0_INIT + PWM0EN_PWM0M_INIT + PWM0EN_PWM01_OEN_INIT \
                               + PWM0EN_PWM0_OEN_INIT+ PWM0EN_PWM0_EN_INIT )
#define  PWM0_PWM0C_INIT       (PWM0C_PWM0IE_INIT + PWM0C_FLT0C_INIT + PWM0C_PWM0S_INIT + PWM0C_CK0_INIT  )

#define  PWM1_PWM1EN_INIT       (PWM1EN_FLT0_MODE_INIT + PWM1EN_EFLT0_INIT + PWM1EN_PWM1M_INIT + PWM1EN_PWM11_OEN_INIT \
                               + PWM1EN_PWM1_OEN_INIT+ PWM1EN_PWM1_EN_INIT )
#define  PWM1_PWM1C_INIT       (PWM1C_PWM1IE_INIT + PWM1C_FLT0C_INIT + PWM1C_PWM1S_INIT + PWM1C_CK0_INIT  )

#define  PWM2_PWM2EN_INIT       (PWM2EN_FLT0_MODE_INIT + PWM2EN_EFLT0_INIT + PWM2EN_PWM2M_INIT + PWM2EN_PWM21_OEN_INIT \
                               + PWM2EN_PWM2_OEN_INIT+ PWM2EN_PWM2_EN_INIT )
#define  PWM2_PWM2C_INIT       (PWM2C_PWM2IE_INIT + PWM2C_FLT0C_INIT + PWM2C_PWM2S_INIT + PWM2C_CK0_INIT  )

#define  PWM3_PWM3C_INIT       (PWM3C_PWM3IE_INIT + PWM3C_PWM3EN_INIT + PWM3C_PWM3OEN_INIT + PWM3C_PWM3S_INIT + PWM3C_PTCK3_INIT)

#define  ADC_ADCC0_INIT        (ADCC0_ADCEN_INIT + ADCC0_ADCST_INIT + ADCC0_VREFO_INIT + ADCC0_VREFS_INIT + ADCC0_INREF_S_INIT)
#define  ADC_ADCC1_INIT        (ADCC1_INIT)
#define  ADC_ADCC2_INIT        (ADCC2_ADCL_ALIGN_INIT + ADCC2_ADCTS_INIT + ADCC2_ADCS_INIT)

#define  ADC_ADCWC_INIT        (ADCWC_AMWEN_INIT)

#define  UART1_SCON_INIT        (UART1_REN_INIT)

#if UART1_MODEL0_ENABLE
#define  UART1_MODEL0_SCON2_INIT        (UART1_MODEL0_UX6_INIT)
#elif UART1_MODEL1_ENABLE
#define  UART1_MODEL1_SCON2_INIT        (UART1_MODEL1_SM2_INIT + 0X02)
#elif UART1_MODEL2_ENABLE
#define  UART1_MODEL2_SCON2_INIT        (UART1_MODEL2_SMOD_INIT + UART1_MODEL2_SM2_INIT +0X04 )
#elif UART1_MODEL3_ENABLE
#define  UART1_MODEL3_SCON2_INIT        (UART1_MODEL3_SM2_INIT + 0X06 )
#endif



/*
*********************************************************************************************************
*	                                   
*********************************************************************************************************
*/
void System_Init(void);

#endif  // HC89S_CONFIG_H_


