/*
 * TM1650.h
 *
 *  Created on: 20220312
 *      Author: User
 */

#ifndef __TM1650_H
#define __TM1650_H
#include <IIC.h>




#define DIG1 0x68
#define DIG2 0x6A
#define DIG3 0x6C
#define DIG4 0x6E


typedef struct 
{   
    uint8_t Flicker_Flag;   //TM1650˸ı־λ
    void (*Init)(void);        //ʼ

    void (*Display_OFF)(IIC_t*);   //ʾoff
    void (*Display_Close)(IIC_t*);  //ʾر
}TM1650_t;



extern void TM1650_Display(IIC_t *Channel, uint16_t Value,uint8_t CHANNEL); //ʾʹ
extern TM1650_t TM1650;


#endif

