/*
 * Timer0.c
 *
 *  Created on: 20220312
 *      Author: User
 */
/* Includes ------------------------------------------------------------------*/
#include <main.h>

/* Private define-------------------------------------------------------------*/

/* Private variables----------------------------------------------------------*/

/* Private function prototypes------------------------------------------------*/
static void Timer0_Init(void); //ʱ0ʼ

/* Public variables-----------------------------------------------------------*/
Timer0_t Timer0 =
	{0, //ͨ1ʱ
	0,//ͨ2ʱ
	 0, //лʾ־
	 0, //ڷͳʱ
	 0, //ڽճʱ
	 0, //ʱжϼ
	 Timer0_Init};

/*
 * @name   Timer0_Init
 * @brief  ʱ0ʼ
 * @param  None
 * @retval None
 */
static void Timer0_Init() // //1@16MHz
{
	TCON1 = 0x00; // Tx0ʱʱΪFosc
	TMOD = 0x00;  // 16λװضʱ/
	// // Tim0ʱ 	= (65536 - 0xFACB) * (1 / (Fosc /TimerƵϵ))
	// //				= 1333 / (16000000 / 12)
	// //				= 1 ms

	// //ʱ1ms
	// //Ƴֵ 	= 65536 - ((1/1000) / (1/(Fosc / TimerƵϵ)))
	// //		   	= 65536 - ((1/1000) / (1/(16000000 / 12)))
	// //			= 65536 - 1333
	// //			= 0xFACB
	TH0 = 0xFA;
	TL0 = 0xCB;	  // T0ʱʱ1ms
	IE |= 0x02;	  //T0ж
	TCON |= 0x10; //ʹT0
	EA = 1;		  //ж
}

/*
 * @name   Timer0_isr()
 * @brief  ʱ0жϺ(1msжһ)
 * @param  None
 * @retval None
 */
/***********ʱ0жϺ***********/
void Timer0_isr() interrupt TIMER0_VECTOR
{
	if (++Timer0.usMCU_Run_Timer >= TIMER0_1000mS)
	{
		Timer0.usMCU_Run_Timer = 0;
		Timer0.TM1650_Flag = ~Timer0.TM1650_Flag;
		Timer0.Error1_Timer++;
		Timer0.Error2_Timer++;
	}
	Timer0.msDelay_Timer++; //ڽճʱ
	Timer0.ADC_Timer++;
	
}
/********************************************************
  End Of File
********************************************************/
